--- 团战提醒脚本

local SETTING_PANEL_NAME = "战斗指示"

local SWTICH_STATE_UNKNOWN = 0
local SWTICH_STATE_OPEN = 1
local SWTICH_STATE_CLOSED = 2

local SGAME_ACCESSBILITY_SETTING_PAGES_TABLE = "cm_cn_tmgp_sgame_accessbility_setting_pages"
local SGAME_ACCESSBILITY_REMIND_INFO = "cm_cn_tmgp_sgame_accessbility_remind_info"

local REMIND_STRATEGY_TYPE_UNKNOWN = 0
local REMIND_STRATEGY_TYPE_TEAM_BATTLE = 2
local REMIND_STRATEGY_TYPE_ENEMY_APPROACH = 3
local REMIND_STRATEGY_TYPE_SUPPORT_MATE = 4

--- 判断团战是否发生时中心两位英雄的最远距离
local TEAMBATTLE_MAX_DISTANCE_CENTERHERO = 30;
--- 判断团战是否发生时距离团战区域的英雄的最远距离
local TEAMBATTLE_MAX_DISTANCE_AREAHERO = 40;

--- 当用户距离团战中心至少多少距离时，就提醒用户
local TEAMBATTLE_NOTICE_LEAST_DISTANCE = 60;
--- 当用户距离团战中心至少多少距离时，就提醒用户
local TEAMBATTLE_NOTICE_MAX_DISTANCE = 300;

--- 团战发生时参团的最低英雄数
local TEAMBATTLE_LEAST_HEROCOUNT = 5;
--- 团战发生时参团的最低友方英雄数
local TEAMBATTLE_LEAST_MATEHEROCOUNT = 2;
--- 团战发生时参团的最低敌方英雄人数
local TEAMBATTLE_LEAST_ENEMYHEROCOUNT = 2;

--- 敌人靠近时用户的移动距离小于多少才认为需要提醒
local ENEMY_APPROACH_USER_MOVE_MAX_DISTANCE = 15;
--- 事件初次发生时用户的位置
local eventHappenedUserPosition

-------------------------- 处理支援队友情况---------------------------------
local SUPPORT_MATE_MATE_DISTANCE = 40;
local SUPPORT_MATE_SUPPORT_DISTANCE = 150;
local SUPPORT_MATE_NOTICE_INTERVAL = 30 * 1000; -- 一次提醒后间隔多长时间再次提醒
local supportMateLastNoticeTime = 0;

------------------- 判断敌人是否在附近---------------------------------
local ENEMY_CLOSE_MATE_DISTANCE = 50;
local ENEMY_CLOSE_ENEMY_DISTANCE = 50;
local NOTICE_INTERVAL = 2 * 1000;

--- 英雄类型
local HERO_TYPE_ENEMY = 1;
local HERO_TYPE_SELF = 2;
local HERO_TYPE_TEAMMATE = 3;

local TYPE_TEAM_BATTLE = "team_battle";
local TYPE_ENEMY_APPROACH = "enemy_approach";
local TYPE_SUPPORT_MATE = "support_mate";

local EVENT_TYPE_TABLE = { TYPE_TEAM_BATTLE, TYPE_ENEMY_APPROACH, TYPE_SUPPORT_MATE };

local HERO_TYPE_TABLE = {
    [HERO_TYPE_TEAMMATE] = "队友",
    [HERO_TYPE_ENEMY] = "敌方",
    [HERO_TYPE_SELF] = "自己"
}

--------- 判断英雄是否在野区中
local TOPLEFT_JUNGLE_RANGE = {
    { pos_x = 61, pos_y = 48 },
    { pos_x = 232, pos_y = 47 },
    { pos_x = 60, pos_y = 215 },
}

local BOTTOMRIGHT_JUNGLE_RANGE = {
    { pos_x = 294, pos_y = 102 },
    { pos_x = 293, pos_y = 275 },
    { pos_x = 111, pos_y = 281 },
}

local SMALL_MAP_RECOGNIZE_RECT = {
    flag = Anchor().TOPLEFT,
    left = 0,
    top = 0,
    width = 700,
    height = 376
}

local checkBoxStateTable = {
    [TYPE_TEAM_BATTLE] = true,
    [TYPE_ENEMY_APPROACH] = true,
    [TYPE_SUPPORT_MATE] = true
}

------ 通知相关---------
local TOAST_SHOW_TIME = 2000;
local TOAST_SHOW_POSITION = {
    anchor = Anchor().BOTTOM,
    x = -375,
    y = -360
};

local NOTICE_TEXT_TABLE = {
    [TYPE_TEAM_BATTLE] = "双方正在激烈团战，请火速支援",
    [TYPE_ENEMY_APPROACH] = "附近有敌人，请小心",
    [TYPE_SUPPORT_MATE] = "队友正在遭到攻击，请支援"
}

local SWITCH_CHECKBOX_TEXT = "开启战斗提醒";
local CHECKBOX_TEXT_TABLE = {
    [TYPE_TEAM_BATTLE] = "发生团战的时候提醒",
    [TYPE_ENEMY_APPROACH] = "敌人靠近我的时候提醒",
    [TYPE_SUPPORT_MATE] = "队友需要支援的时候提醒"
}

-- 时间提醒的冷却期
local EVENT_NOTICE_INTERVAL_TABLE = {
    [TYPE_TEAM_BATTLE] = 60 * 1000,
    [TYPE_ENEMY_APPROACH] = 30 * 1000,
    [TYPE_SUPPORT_MATE] = 30 * 1000
}

-- 事件识别阶段的时间
local EVENT_RECOGNIZE_DURATION_TABLE = {
    [TYPE_TEAM_BATTLE] = 0 * 1000,
    [TYPE_ENEMY_APPROACH] = 0 * 1000,
    [TYPE_SUPPORT_MATE] = 0 * 1000
}

-- 事件分析阶段的时间
local EVENT_ANALYZED_DURATION_TABLE = {
    [TYPE_TEAM_BATTLE] = 3 * 1000,
    [TYPE_ENEMY_APPROACH] = 3 * 1000,
    [TYPE_SUPPORT_MATE] = 3 * 1000
}

-- 事件上次发生的时间
local eventLastHappenedTimeTable = {
    [TYPE_TEAM_BATTLE] = 0,
    [TYPE_ENEMY_APPROACH] = 0,
    [TYPE_SUPPORT_MATE] = 0
}

-- 事件上次提醒的时间
local eventLastNoticeTimeTable = {
    [TYPE_TEAM_BATTLE] = 0,
    [TYPE_ENEMY_APPROACH] = 0,
    [TYPE_SUPPORT_MATE] = 0
}

-- 事件总的识别次数
local eventTotalRecognizeCountTable = {
    [TYPE_TEAM_BATTLE] = 0,
    [TYPE_ENEMY_APPROACH] = 0,
    [TYPE_SUPPORT_MATE] = 0
}
-- 事件总的发生次数
local eventTotalHappenedCountTable = {
    [TYPE_TEAM_BATTLE] = 0,
    [TYPE_ENEMY_APPROACH] = 0,
    [TYPE_SUPPORT_MATE] = 0
}

local mathLib

local tvMateCount
local tvEnemyCount
local tvIsSelfExist

local cbSwitch
local checkboxTable
local isCbSwitchChecked = true

local floatWindow

local lastNoticeTime = 0
local hasNoticed = false
local heros
local mates
local enemies
local user

local coreFightAreas
local peripheralAreas

local lastFullCover
local lastMapMode

local BATTLE_TAG = "battle_notice"

local function printLog(msg)
    commonlib_print(BATTLE_TAG, msg)
end

local function debugState(mates, enemies, user)
    commonlib_runOnUIThread(function()

        if tvMateCount ~= nil then
            tvMateCount:setText("我方英雄数：" .. tostring(#mates))
        end

        if tvEnemyCount ~= nil then
            tvEnemyCount:setText("敌方英雄数：" .. tostring(#enemies))
        end

        if tvIsSelfExist ~= nil then
            tvIsSelfExist:setText("是否包含自己：" .. tostring(user ~= nil))
        end
    end)
end

local function printHeroInfo(hero)
    printLog("pro_y = " .. tostring(hero.pos_x) .. ", pos_y = " .. tostring(hero.pos_y) .. "所属方：" .. tostring(HERO_TYPE_TABLE[hero.type]));
end

local function printHeros()
    printLog("获取到敌方英雄数：" .. tostring(#enemies) .. "，己方英雄数：" .. tostring(#mates) .. "，是否获取到自己：" .. tostring(user ~= nil));
    for index = 1, #heros do
        printLog("开始打印第" .. tostring(index) .. "个英雄信息:");
        printHeroInfo(heros[index]);
    end
end

local function convertRemindStrategyForReport(type)
    local strategyType = REMIND_STRATEGY_TYPE_UNKNOWN
    if type == TYPE_TEAM_BATTLE then
        strategyType = REMIND_STRATEGY_TYPE_TEAM_BATTLE
    elseif type == TYPE_ENEMY_APPROACH then
        strategyType = REMIND_STRATEGY_TYPE_ENEMY_APPROACH
    elseif type == TYPE_SUPPORT_MATE then
        strategyType = REMIND_STRATEGY_TYPE_SUPPORT_MATE
    end
    return strategyType
end

local function convertSwitchStateToInt(switchStatus)
    local switchState = SWTICH_STATE_UNKNOWN
    if switchStatus ~= nil and not switchStatus then
        switchState = SWTICH_STATE_CLOSED
    elseif switchStatus then
        switchState = SWTICH_STATE_OPEN
        --    elseif not switchStatus then
        --        switchState = SWTICH_STATE_CLOSED
    end
    return switchState
end

local function reportBattleNoticeSwitchStatus()
    local reportLib = Report();
    if reportLib ~= nil then
        reportLib:report({
            table_name = SGAME_ACCESSBILITY_SETTING_PAGES_TABLE,
            report_data = {
                skin = 0,
                battle = convertSwitchStateToInt(checkBoxStateTable.TYPE_TEAM_BATTLE),
                enemy_nearby = convertSwitchStateToInt(checkBoxStateTable.TYPE_ENEMY_APPROACH),
                teammate = convertSwitchStateToInt(checkBoxStateTable.TYPE_SUPPORT_MATE),
                enemy_disappear = 0,
                buff_time = 0
            }
        })
    end
end

local function reportRemindStrategy(type)
    printLog("reportRemindStrategy=====================================");
    local reportLib = Report();
    if reportLib ~= nil then
        reportLib:report({
            table_name = SGAME_ACCESSBILITY_REMIND_INFO,
            report_data = { remind_strategy = convertRemindStrategyForReport(type) }
        })
    end
end

--- 获取两点间的直线距离
local function getPointDistance(one, other)
    if one == nil or other == nil then
        -- 有一点不存在，就认为它们无限远
        return 100000;
    end

    local xDis = mathLib.abs(one.pos_x - other.pos_x);
    local yDis = mathLib.abs(one.pos_y - other.pos_y);
    return mathLib.sqrt(xDis * xDis + yDis * yDis);
end

--- 获取某一区域的矩形中心
local function getAreaCenter(area)
    local maxX, minX, maxY, minY

    for index, hero in pairs(area) do
        local pos_x = hero.pos_x;
        local pos_y = hero.pos_y;

        if maxX == nil then
            maxX = pos_x;
        end
        if minX == nil then
            minX = pos_x;
        end
        if maxY == nil then
            maxY = pos_y;
        end
        if minY == nil then
            minY = pos_y;
        end

        if pos_x > maxX then
            maxX = pos_x;
        end
        if pos_x < minX then
            minX = pos_x;
        end
        if pos_y > maxY then
            maxY = pos_y;
        end
        if pos_y < minY then
            minY = pos_y;
        end
    end
    local center = {};
    center.pos_x = (maxX + minX) / 2;
    center.pos_y = (maxY + minY) / 2;
    return center;
end

local function getTriangleArea(triangle)
    local a = getPointDistance(triangle[1], triangle[2]);
    local b = getPointDistance(triangle[2], triangle[3]);
    local c = getPointDistance(triangle[3], triangle[1]);

    local p = (a + b + c) / 2;

    return mathLib.sqrt(p * (p - a) * (p - b) * (p - c));
end

local function isPointInTriangle(point, triangle)
    local area1 = getTriangleArea({ point, triangle[1], triangle[2] });
    local area2 = getTriangleArea({ point, triangle[1], triangle[3] });
    local area3 = getTriangleArea({ point, triangle[2], triangle[3] });

    local totalArea = getTriangleArea(triangle);

    local areaDistance = mathLib.abs(totalArea - (area1 + area2 + area3));
    return areaDistance < 1500;
end

local function isHeroInJungle(hero)
    return isPointInTriangle(hero, TOPLEFT_JUNGLE_RANGE) or isPointInTriangle(hero, BOTTOMRIGHT_JUNGLE_RANGE);
end

--- 获取用户到某一区域的中心的距离
local function getHeroAreaDistance(hero, area)
    if hero == nil then
        return 10000;
    end
    local areaCenter = getAreaCenter(area);
    return getPointDistance(hero, areaCenter);
end

--- 判断一个区域是否包含某个英雄
local function hasHero(oneArea, hero)
    for index, target in pairs(oneArea) do
        if target == hero then
            return true;
        end
    end
    return false;
end

--- 当前英雄集合中是否存在与目标英雄接近的英雄
local function hasHeroClose(heros, targetHero, standardDis)
    for index, hero in pairs(heros) do
        -- 当前遍历出的英雄不是目标英雄
        if hero ~= targetHero then
            local distance = getPointDistance(hero, targetHero);
            if distance < standardDis then
                return true;
            end
        end
    end
    return false;
end

--- 判断一个区域是否包含另一个区域
local function hasArea(oneArea, otherArea)
    for index, hero in pairs(otherArea) do
        if not hasHero(oneArea, hero) then
            return false;
        end
    end
    return true;
end

--- 判断一个外围区是否包含核心交战区
local function hasCoreFightArea(peripheralArea, coreFightGroup)
    for index, coreFightArea in pairs(coreFightGroup) do
        if hasArea(peripheralArea, coreFightArea) then
            return true;
        end
    end
    return false;
end

--- 获取指定范围内目标英雄身边的英雄
local function getCloseHeros(heros, targetHero, distance)
    local result = {};
    for index, hero in ipairs(heros) do
        if hero ~= targetHero and getPointDistance(hero, targetHero) <= distance then
            result[#result + 1] = hero;
        end
    end
    return result;
end

-- 获取该区域内的唯一队友，若该区域不存在队友或队友数大于1，则返回nil
local function getOnlyMateInArea(area)
    local target = nil;
    for index, hero in pairs(area) do
        if hero.type == HERO_TYPE_TEAMMATE then
            -- target 已被赋过值，但现在又遍历出一名队友，则说明队友数不为1
            if target ~= nil then
                return nil;
            else
                target = hero;
            end
        end
    end
    return target;
end

local function isHeroCountValid()
    printLog("判断获取到的英雄个数是否有效");
    if user == nil then
        printLog("未获取到当前用户");
        return false;
    end

    if #mates > 4 then
        printLog("获取到的队友个数大于4个");
        return false;
    end

    if #enemies > 5 then
        printLog("获取到的敌人个数大于4个")
        return false;
    end

    printLog("获取到的英雄个数有效");
    return true;
end

------------------ 处理团战--------------------------
--[[
几个概念：
    核心区域：由一些距离小于30的英雄组成的区域
    核心交战区域： 至少有一敌一友两名英雄的距离小于30的核心区
    外围区域：由一些距离小于30的英雄组成的区域（包含核心区）
    外围交战区域：满足团战条件的外围区：
         1. 包含一个核心交战区
         2. 该区内每一方的敌我数量都不小于两个
         3. 该区域内英雄总数不小于 5

]]

--- 将指定英雄合集按类型分类
--- @param 需进行分类的英雄集合
--- @return mates 友方英雄集合,不包含用户自己
--- @return enemies 敌方英雄集合
--- @return user 用户信息
local function groupHero(heros)
    local mateGroup = {};
    local enemyGroup = {};
    local user

    for index, hero in pairs(heros) do
        if hero.type == HERO_TYPE_TEAMMATE then
            mateGroup[#mateGroup + 1] = hero;
        elseif hero.type == HERO_TYPE_ENEMY then
            enemyGroup[#enemyGroup + 1] = hero;
        elseif hero.type == HERO_TYPE_SELF then
            user = hero;
        end
    end

    return mateGroup, enemyGroup, user;
end

--- 除去table中的nil值，并将nil后面的值提前
local function polishingTable(table, length)
    local newTable = {};
    for index = 1, length do
        local element = table[index];
        if element ~= nil then
            newTable[#newTable + 1] = element;
        end
    end
    return newTable;
end

--- 根据距离判断两个区域是否可以合并
local function isAreaCanCombine(oneArea, otherArea, distance)
    for i, oneHero in pairs(oneArea) do
        for j, otherHero in pairs(otherArea) do
            local heroDistance = getPointDistance(oneHero, otherHero);
            if heroDistance <= distance then
                return true;
            end
        end
    end
    return false;
end

--- 合并两个区域
local function combineArea(targetArea, combinedArea)
    for index, hero in pairs(combinedArea) do
        if hero ~= nil then
            targetArea[#targetArea + 1] = hero;
        end
    end
    return targetArea;
end

--- 从核心组中选出所有核心交战区组成核心交战组
local function getCoreFightAreas(coreGroup)
    local coreFightGroup = {};

    for index, area in pairs(coreGroup) do
        local mates, enemies, user = groupHero(area);
        mates[#mates + 1] = user;
        if #mates > 0 and #enemies > 0 then
            coreFightGroup[#coreFightGroup + 1] = area;
        end
    end

    return coreFightGroup;
end

--- 根据核心交战组及外围组的信息判断此刻是否发生了团战以及是否应该提醒用户
--- @param coreFightGroup 核心交战组
--- @param peripheralGroup 外围组
--- @param user 用户信息
--- @return isMomentInTeamBattle 当前是否处于团战状态
--- @return shouldNotice 是否应该进行提醒
local function isInTeamBattle(coreFightGroup, peripheralGroup, user)
    printLog("开始判断此刻团战是否发生");

    -- 遍历每一个外围区，判断它是不是外围交战区
    printLog("遍历每一个外围区，判断它是不是外围交战区");
    for index, peripheralArea in pairs(peripheralGroup) do
        printLog("开始遍历第" .. index .. "个外围区");
        local mates, enemies, userTemp = groupHero(peripheralArea);
        mates[#mates + 1] = userTemp;
        -- 判断英雄数量是否满足团战条件
        printLog("该区域中的敌友英雄数量：" .. #enemies .. "，" .. #mates);
        local hasEnoughHero = #peripheralArea >= TEAMBATTLE_LEAST_HEROCOUNT and #mates >= TEAMBATTLE_LEAST_MATEHEROCOUNT and #enemies >= TEAMBATTLE_LEAST_ENEMYHEROCOUNT;
        if hasEnoughHero then
            -- 判断是否包含至少一个核心交战区，若包含，则该区域是团战区
            if hasCoreFightArea(peripheralArea, coreFightGroup) then
                printLog("该外围区包含一个核心交战区，是团战区");
                if userTemp == nil then
                    -- 获取用户到该区域的距离
                    printLog("当前用户不在该区域内");
                    local userAreaDis = getHeroAreaDistance(user, peripheralArea);
                    printLog("获取用户到该区域的距离:" .. tostring(userAreaDis));
                    return userAreaDis > TEAMBATTLE_NOTICE_LEAST_DISTANCE and userAreaDis < TEAMBATTLE_NOTICE_MAX_DISTANCE;
                else
                    printLog("当前用户不在该区域内");
                end
            end
        else
            printLog("该区域中敌我英雄数不满足要求");
        end
    end
    printLog("当前团战并未发生");
    return false;
end

--- 根据指定距离将英雄划分到不同区域，并形成一个组
--- @param heros 待划分区域的英雄
--- @param distance 指定的距离
local function getAreasByDistance(heros, distance)
    local group = {};

    if commonlib_isTableEmpty(heros) then
        return group;
    end

    local heroCount = #heros;
    if heroCount == 1 then
        group[1] = { heros[1] };
        return group;
    end

    -- 初始阶段，一个英雄一个区域，这些区域共同组成一个组
    for index = 1, heroCount do
        local area = {};
        area[1] = heros[index];
        group[index] = area;
    end

    -- 从尾部开始，依次向前合并区域
    for tailIndex = #group, 1, -1 do
        -- 取出尾部的area
        local tailArea = group[tailIndex];
        for headIndex = tailIndex - 1, 1, -1 do
            local headArea = group[headIndex];
            if isAreaCanCombine(headArea, tailArea, distance) then
                group[headIndex] = combineArea(headArea, tailArea);
                group[tailIndex] = nil;
                break;
            end
        end
    end

    return polishingTable(group, heroCount);
end

local function isEnemyApproach(mates, enemies, user)
    printLog("开始处理敌人靠近情况");

    local hasMateClose = hasHeroClose(mates, user, ENEMY_CLOSE_MATE_DISTANCE);
    local hasEnemyClose = hasHeroClose(enemies, user, ENEMY_CLOSE_ENEMY_DISTANCE);

    if hasMateClose then
        printLog("有队友在附近，不认为是敌人靠近状态");
        return false;
    else
        printLog("没有队友在附近");
    end

    if not isHeroInJungle(user) then
        printLog("当前用户不在野区中，不认为是敌人靠近状态")
        return false;
    else
        printLog("当前用户在野区中");
    end

    if hasEnemyClose then
        printLog("有敌人在附近");
        local nearEnemies = getCloseHeros(enemies, user, ENEMY_CLOSE_ENEMY_DISTANCE);
        for index, nearEnemy in ipairs(nearEnemies) do
            if isHeroInJungle(nearEnemy) then
                printLog("用户身边的敌人中有一个在野区中,认为是敌人靠近状态");
                return true;
            end
        end
        printLog("用户身边的敌人都不在野区中");
    else
        printLog("没有敌人在附近");
    end

    printLog("不认为是敌人靠近状态");
    return false;
end

local function isMateNeedSupport(coreFightGroup, mates, user)
    printLog("开始判断队友是否需要支援");
    for index, coreFightArea in pairs(coreFightGroup) do
        printLog("开始遍历第" .. tostring(index) .. "个核心交战区");
        local target = getOnlyMateInArea(coreFightArea);

        -- 该区域内仅存在一名队友和一名敌人
        local shouldSupportMate = (target ~= nil and #coreFightArea == 2);
        -- 该队友附近没有其它队友
        shouldSupportMate = shouldSupportMate and not hasHeroClose(mates, target, SUPPORT_MATE_MATE_DISTANCE);
        -- 当前用户与该队友距离在一定范围内
        shouldSupportMate = shouldSupportMate and not (getPointDistance(user, target) < SUPPORT_MATE_SUPPORT_DISTANCE);
        -- 该队友在野区中
        shouldSupportMate = shouldSupportMate and isHeroInJungle(target);

        if shouldSupportMate then
            printLog("队友需要支援");
            return true;
        end
    end
    printLog("队友不需要支援");
    return false;
end

local function isEventHappened(eventType)
    printLog("判断此刻事件是否发生：" .. tostring(eventType));
    local isHappened = false;
    if eventType == TYPE_TEAM_BATTLE then
        isHappened = isInTeamBattle(coreFightAreas, peripheralAreas, user);
    elseif eventType == TYPE_ENEMY_APPROACH then
        isHappened = isEnemyApproach(mates, enemies, user);
    elseif eventType == TYPE_SUPPORT_MATE then
        isHappened = isMateNeedSupport(coreFightAreas, mates, user);
    end
    return isHappened;
end

local function isNoticeCountDownFinished(eventType)
    printLog("开始判断提醒倒计时是否结束：" .. eventType);
    local eventLastNoticeTime = eventLastNoticeTimeTable[eventType];
    local currentTime = commonlib_getCurrentTime();
    local timeDistance = currentTime - eventLastNoticeTime;
    printLog("事件上次提醒：" .. tostring(eventLastNoticeTime) .. ", 当前时间：" .. tostring(currentTime) .. ", 差值：" .. tostring(timeDistance));
    if timeDistance <= EVENT_NOTICE_INTERVAL_TABLE[eventType] then
        printLog("提醒倒计时还未结束");
        return false;
    end
    printLog("提醒倒计时已经结束");
    return true;
end

local function resetEventTable(eventType)
    eventTotalRecognizeCountTable[eventType] = 0;
    eventTotalHappenedCountTable[eventType] = 0;
end

local function onNoticed()
end

local function notice(eventType)
    printLog("开始提醒用户：" .. tostring(eventType));

    commonlib_runOnUIThread(function()
        floatWindow:addTimeMessageRemindView(NOTICE_TEXT_TABLE[eventType], TOAST_SHOW_TIME, TOAST_SHOW_POSITION.anchor, TOAST_SHOW_POSITION.x, TOAST_SHOW_POSITION.y, true, 2, onNoticed);
    end);

    eventLastNoticeTimeTable[eventType] = commonlib_getCurrentTime();
    lastNoticeTime = commonlib_getCurrentTime();

    hasNoticed = true;
--    reportRemindStrategy(type);
end

local function handleEvent(eventType)
    printLog("开始处理事件:" .. tostring(eventType));

    if hasNoticed then
        printLog("此帧内已经做过一次提醒，不再处理");
        return;
    end

    if not checkBoxStateTable[eventType] then
        printLog("Checkbox 未选中，不错处理")
        return;
    end

    if not isNoticeCountDownFinished(eventType) then
        return;
    end

    local currentTime = commonlib_getCurrentTime();
    local eventLastHappenedTime = eventLastHappenedTimeTable[eventType];
    local timeDistance = currentTime - eventLastHappenedTime;
    if 0 <= timeDistance and timeDistance <= EVENT_RECOGNIZE_DURATION_TABLE[eventType] then
        printLog("当前处于事件识别阶段");
        eventTotalRecognizeCountTable[eventType] = eventTotalRecognizeCountTable[eventType] + 1;

        if isEventHappened(eventType) then
            printLog("检测到事件正在发生");
            eventTotalHappenedCountTable[eventType] = eventTotalHappenedCountTable[eventType] + 1;
        end
    elseif EVENT_RECOGNIZE_DURATION_TABLE[eventType] < timeDistance and timeDistance <= EVENT_ANALYZED_DURATION_TABLE[eventType] then
        printLog("当前处于结果分析阶段");
        -- 在此时间段内已经进行过分析了，就不在做分析
        if eventTotalRecognizeCountTable[eventType] == 0 then
            printLog("在此时间段内已经进行过分析了，就不在做分析");
            return;
        end

        local happenedRate = eventTotalHappenedCountTable[eventType] / eventTotalRecognizeCountTable[eventType];
        printLog("事件发生比率为：" .. tostring(happenedRate));
        if happenedRate >= 0.5 then
            if eventType == TYPE_ENEMY_APPROACH then
                local userMoveDistance = getPointDistance(user, eventHappenedUserPosition);
                printLog("用户移动距离：" .. tostring(userMoveDistance));
                if userMoveDistance <= ENEMY_APPROACH_USER_MOVE_MAX_DISTANCE then
                    notice(eventType)
                end
            else
                notice(eventType);
            end
        end
        resetEventTable(eventType);
    else
        printLog("当前处于事件未发生阶段");
        resetEventTable(eventType);
        if isEventHappened(eventType) then
            printLog("当前事件正在发生，由未发生阶段变成了发生阶段");
            eventTotalHappenedCountTable[eventType] = 1;
            eventTotalRecognizeCountTable[eventType] = 1;
            eventLastHappenedTimeTable[eventType] = commonlib_getCurrentTime();
            eventHappenedUserPosition = user;
        end
    end
end

local function initVariable()
    lastFullCover = false
    lastMapMode = nil
    mathLib = require("math")

    floatWindow = UnClickableFloatView();
    tvMateCount = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, 160, 400, 3)
    tvEnemyCount = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, 160, 440, 3)
    tvIsSelfExist = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, 160, 480, 3)

    local coordinateTool = CoordinateTool()
    TOAST_SHOW_POSITION.x = 0
    TOAST_SHOW_POSITION.y = -coordinateTool:dp2Pix(92)
end

local function destroyView(view)
    if view ~= nil then
        view:destroy()
        view = nil
    end
end

local function destroyViews()
    destroyView(cbSwitch)

    for eventType, checkbox in pairs(checkboxTable) do
        destroyView(checkbox)
    end
end

local function unInitVariable()
    mathLib = nil
    floatWindow = nil
end

local function setAllCheckboxState(state)
    for eventType, checkbox in pairs(checkboxTable) do
        checkbox:setEnabled(state)
        checkbox:setChecked(state)

        checkBoxStateTable[eventType] = state;
    end
end

local KEY_IS_SWITCH_CB_CHECKED = "key_is_switch_cb_checked";
local KEY_IS_CB_CHECKED_TABLE = {
    [TYPE_TEAM_BATTLE] = "key_is_team_battle_cb_checked",
    [TYPE_ENEMY_APPROACH] = "key_is_enemy_approach_cb_checked",
    [TYPE_SUPPORT_MATE] = "key_is_support_mate_cb_checked"
};

local function saveCheckboxState()
    printLog("开始储存Checkbox的设置值")
    commonlib_setSharedPrefBoolean(KEY_IS_SWITCH_CB_CHECKED, isCbSwitchChecked);
    for eventType, key in pairs(KEY_IS_CB_CHECKED_TABLE) do
        commonlib_setSharedPrefBoolean(key, checkBoxStateTable[eventType]);
    end
end

local function onCheckboxSelected(checkboxId, isChecked)
    printLog("checkbox : checkbox is callback: " .. checkboxId);
    if checkboxId == cbSwitch:getId() then
        isCbSwitchChecked = isChecked;
        setAllCheckboxState(isCbSwitchChecked);
    end

    for eventType, checkbox in pairs(checkboxTable) do
        if checkboxId == checkbox:getId() then
            checkBoxStateTable[eventType] = isChecked;
        end
    end

    -- 所有的Checkbox 未选中，则将总开关置为未选中
    printLog("开始判断是否所有的Checkbox 都未选中");
    local isAllCbUnSelected = true;
    for eventType, checkboxState in pairs(checkBoxStateTable) do
        printLog("当前Checkbox 是否选中： " .. tostring(eventType) .. " : " .. tostring(checkboxState));
        if checkboxState then
            isAllCbUnSelected = false;
        end
    end
    if isAllCbUnSelected then
        cbSwitch:setChecked(false);
    end

    saveCheckboxState();
end

--- 设置面板相关
local function initConfigUI()
    printLog("initConfigUI begin")

    local settingView = SettingView()
    local tabPage = settingView:addTableView(SETTING_PANEL_NAME)

    local cbParam;
    local cbParamProperty;

    cbParam = create("RelativeLayoutParam");
    cbParamProperty = {
        layout_marginTop = "10dp",
        layout_marginLeft = "10dp"
    };
    cbParam:setLayoutParam(cbParamProperty);
    cbSwitch = tabPage:addCheckBoxView(SWITCH_CHECKBOX_TEXT, true, cbParam, onCheckboxSelected);

    checkboxTable = {};
    local lastCb = cbSwitch;
    for idnex, eventType in ipairs(EVENT_TYPE_TABLE) do
        cbParam = create("RelativeLayoutParam");
        cbParamProperty = {
            layout_marginTop = "20dp",
            layout_marginLeft = "25dp",
            layout_below = lastCb:getId()
        };
        cbParam:setLayoutParam(cbParamProperty);
        checkboxTable[eventType] = tabPage:addCheckBoxView(CHECKBOX_TEXT_TABLE[eventType], true, cbParam, onCheckboxSelected);
        lastCb = checkboxTable[eventType];
    end

    cbSwitch:setChecked(commonlib_getSharedPrefBoolean(KEY_IS_SWITCH_CB_CHECKED, true));
    for eventType, key in pairs(KEY_IS_CB_CHECKED_TABLE) do
        checkboxTable[eventType]:setChecked(commonlib_getSharedPrefBoolean(key, true));
    end
end

local function resetDebugState()
    printLog("resetDebugState clear info")
    debugState({}, {}, nil)
end

-- 是否应该进行战斗提醒的真正处理
local function handleWhenGameRunning()
    heros = commonlib_recognizeFindObjectPosition(SMALL_MAP_RECOGNIZE_RECT)
    printLog("获取到的英雄数量:" .. #heros)

    mates, enemies, user = groupHero(heros)
    printHeros();
    debugState(mates, enemies, user)

    if not isHeroCountValid() then
        return
    end

    -- 根据距离获取组
    -- 距离小于10的组(核心组)，该组可能包含多个核心区
    local coreAreas = getAreasByDistance(heros, TEAMBATTLE_MAX_DISTANCE_CENTERHERO);
    -- 从核心组中挑选出存在至少一敌一友的组（核心交战组），该组可能包含多个核心交战区
    coreFightAreas = getCoreFightAreas(coreAreas);
    printLog("核心交战组的区域数：" .. #coreFightAreas);

    -- 距离小于20的组（外围组），该组可能包含多个外围区
    peripheralAreas = getAreasByDistance(heros, TEAMBATTLE_MAX_DISTANCE_AREAHERO);
    printLog("外围组的区域数：" .. #peripheralAreas);

    hasNoticed = false;

    for index, eventType in ipairs(EVENT_TYPE_TABLE) do
        handleEvent(eventType);
    end
end

local function onJustEnterGame()
    printLog("onJustEnterGame begin")
--    reportBattleNoticeSwitchStatus()
end

local function onGameRunning()
    if not isCbSwitchChecked then
        printLog("Checkbox 未选中，不做战斗提醒处理")
        resetDebugState()
        return
    end

    if commonlib_getCurrentTime() - lastNoticeTime < NOTICE_INTERVAL then
        printLog("距上一次提醒时间较近，不做提醒")
        resetDebugState()
        return
    end

    if commonlib_isFullCoverOrMapExpand(lastFullCover, lastMapMode) then
        printLog("发生了全遮挡或者小地图展开，不做战斗提醒处理")
        resetDebugState()
        return
    end

    handleWhenGameRunning()
end

local function onGameOver()
    resetDebugState()
end

local function onFullCoverStateChange(isFullCover)
    printLog("onFullCoverStateChange isFullCover: " .. tostring(isFullCover))
    lastFullCover = isFullCover
end

local function onMapModeChange(mapMode)
    printLog("onMapModeChanged mapMode: " .. tostring(mapMode))
    lastMapMode = mapMode
end

local function registerGameEvents()
    commonlib_registerCallback(common_game_events_callbacks.common_just_enter_game, onJustEnterGame)
    commonlib_registerCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_registerCallback(common_game_events_callbacks.common_full_cover, onFullCoverStateChange)
    commonlib_registerCallback(common_game_events_callbacks.common_map_mode, onMapModeChange)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks.common_just_enter_game, onJustEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_unregisterCallback(common_game_events_callbacks.common_full_cover, onFullCoverStateChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_map_mode, onMapModeChange)
end

local function init()
    printLog("fight init")
    registerGameEvents()
    initVariable()
    initConfigUI()
end

local function uninit()
    printLog("fight uninit")
    lastFullCover = false
    lastMapMode = nil
    destroyViews()
    unInitVariable()
    unregisterGameEvents()
end

table.insert(common_life_circle_callbacks, { init, uninit })