--- Buff(目前支持红蓝Buff)提醒脚本

local SETTING_PANEL_NAME = "buff提醒"

--- 小地图坐标
local SMALL_MAP_RECOGNIZE_RECT = {
    flag = Anchor().TOPLEFT,
    left = 0,
    top = 0,
    width = 610,
    height = 378
}

--- 己方红Buff坐标
local RED_BUFF_RECT = {
    flag = Anchor().TOPLEFT,
    left = 168,
    top = 260,
    width = 21,
    height = 19
}

--- 己方蓝Buff坐标
local BLUE_BUFF_RECT = {
    flag = Anchor().TOPLEFT,
    left = 82,
    top = 158,
    width = 21,
    height = 19
}

--- 敌方蓝Buff坐标
local ENEMY_BLUE_BUFF_RECT = {
    flag = Anchor().TOPLEFT,
    left = 238,
    top = 163,
    width = 21,
    height = 19
}

--- 敌方红Buff坐标
local ENEMY_RED_BUFF_RECT = {
    flag = Anchor().TOPLEFT,
    left = 152,
    top = 61,
    width = 21,
    height = 19
}

--左出装时间坐标
local LEFT_SHOP_TIME_NUM1_TABLE = {
    flag = Anchor().TOPRIGHT,
    left = -527,
    top = 10,
    width = 13,
    height = 18
}

local LEFT_SHOP_TIME_NUM2_TABLE = {
    flag = Anchor().TOPRIGHT,
    left = -515,
    top = 10,
    width = 13,
    height = 18
}

local LEFT_SHOP_TIME_NUM3_TABLE = {
    flag = Anchor().TOPRIGHT,
    left = -497,
    top = 10,
    width = 13,
    height = 18
}

local LEFT_SHOP_TIME_NUM4_TABLE = {
    flag = Anchor().TOPRIGHT,
    left = -485,
    top = 10,
    width = 13,
    height = 18
}
--右侧出装时间表
local RIGHT_SHOP_TIME_NUM1_TABLE = {
    flag = Anchor().TOPRIGHT,
    left = -303,
    top = 69,
    width = 13,
    height = 18
}

local RIGHT_SHOP_TIME_NUM2_TABLE = {
    flag = Anchor().TOPRIGHT,
    left = -291,
    top = 69,
    width = 13,
    height = 18
}

local RIGHT_SHOP_TIME_NUM3_TABLE = {
    flag = Anchor().TOPRIGHT,
    left = -273,
    top = 69,
    width = 13,
    height = 18
}

local RIGHT_SHOP_TIME_NUM4_TABLE = {
    flag = Anchor().TOPRIGHT,
    left = -261,
    top = 69,
    width = 13,
    height = 18
}
--- 设置项中Buff倒计时的checkbox是否被选中
local isBuffCountDown = false;

local KEY_IS_BUFF_CHECKED = "key_is_buff_checked"

local BUFF_SWITCH_TEXT = "开启BUFF提醒"
local BUFF_REMIND_TEXT = "开启红蓝BUFF刷新提醒"
local BUFF_COUNT_DOWN_TEXT = "显示红蓝BUFF刷新倒计时"
local BUFF_MIN_SIMILARITY = 8; -- Buff图片最小相似度
local buffSimilarityTable = {}

local HERO_COVERED_BUFF_DISTANCE = 28;
local HERO_NEARBY_BUFF_DISTANCE = 35;

local BUFF_STATE_EXIST = 1 -- Buff存在状态
local BUFF_STATE_UNKNOW = 0 -- Buff存在状态不确定
local BUFF_COUNT_DOWN_TIME = 90000
local BUFF_COUNT_DOWN_TIME_THIRTY = 30000
local RED_BUFF_COUNT_DOWN_TIME = 90000 -- Buff倒计时时间
local BLUE_BUFF_COUNT_DOWN_TIME = 90000
local ENEMY_RED_BUFF_COUNT_DOWN_TIME = 90000
local ENEMY_BLUE_BUFF_COUNT_DOWN_TIME = 90000
local BUFF_AVAIL_TIME = 6000 -- Buff存在状态有效时间

local IF_COUNT_DOWN = 0;

local SGAME_ACCESSBILITY_REMIND_INFO = "cm_cn_tmgp_sgame_accessbility_remind_info"
local SGAME_ACCESSBILITY_SETTING_PAGES_TABLE = "cm_cn_tmgp_sgame_accessbility_setting_pages"

local BUFF_TYPE_RED = 1
local BUFF_TYPE_BULE = 2
local BUFF_TYPE_ENEMY_RED = 3
local BUFF_TYPE_ENEMY_BLUE = 4

local REMIND_STRATEGY_BUFF_TIME = 1

local mBuffRectTable = {
    [BUFF_TYPE_RED] = RED_BUFF_RECT,
    [BUFF_TYPE_BULE] = BLUE_BUFF_RECT,
    [BUFF_TYPE_ENEMY_RED] = ENEMY_RED_BUFF_RECT,
    [BUFF_TYPE_ENEMY_BLUE] = ENEMY_BLUE_BUFF_RECT
}

local mBuffRectCenterPointTable = {
    [BUFF_TYPE_RED] = { x = 178, y = 270 },
    [BUFF_TYPE_BULE] = { x = 92, y = 168 },
    [BUFF_TYPE_ENEMY_RED] = { x = 162, y = 71 },
    [BUFF_TYPE_ENEMY_BLUE] = { x = 248, y = 173 }
}

local mBuffCachedStatus = {
    [BUFF_TYPE_RED] = BUFF_STATE_UNKNOW,
    [BUFF_TYPE_BULE] = BUFF_STATE_UNKNOW,
    [BUFF_TYPE_ENEMY_RED] = BUFF_STATE_UNKNOW,
    [BUFF_TYPE_ENEMY_BLUE] = BUFF_STATE_UNKNOW
}

local mBuffCachedStateRecordTime = {
    [BUFF_TYPE_RED] = 0,
    [BUFF_TYPE_BULE] = 0,
    [BUFF_TYPE_ENEMY_RED] = 0,
    [BUFF_TYPE_ENEMY_BLUE] = 0
}

local mIsBuffCountDownRunning = {
    [BUFF_TYPE_RED] = false,
    [BUFF_TYPE_BULE] = false,
    [BUFF_TYPE_ENEMY_RED] = false,
    [BUFF_TYPE_ENEMY_BLUE] = false
}
--buff缓存状态是否有效
local mIsBuffCachedStateAvail = {
    [BUFF_TYPE_RED] = false,
    [BUFF_TYPE_BULE] = false,
    [BUFF_TYPE_ENEMY_RED] = false,
    [BUFF_TYPE_ENEMY_BLUE] = false
}
--倒计时开始时间
local mBuffCountDownStartTime = {
    [BUFF_TYPE_RED] = 0,
    [BUFF_TYPE_BULE] = 0,
    [BUFF_TYPE_ENEMY_RED] = 0,
    [BUFF_TYPE_ENEMY_BLUE] = 0
}

local mBuffTag = {
    [BUFF_TYPE_RED] = "红Buff",
    [BUFF_TYPE_BULE] = "蓝Buff",
    [BUFF_TYPE_ENEMY_RED] = "敌方红Buff",
    [BUFF_TYPE_ENEMY_BLUE] = "敌方蓝Buff"
}

local mBuffList = {
    [BUFF_TYPE_RED] = nil,
    [BUFF_TYPE_BULE] = nil,
    [BUFF_TYPE_ENEMY_RED] = nil,
    [BUFF_TYPE_ENEMY_BLUE] = nil
}

local COUNT_DOWN_DOUBLE_ZERO = "00"
local COUNT_DOWN_ZERO = "0"
local COUNT_DOWN_ONE = "1"
local COUNT_DOWN_TWO = "2"
local COUNT_DOWN_THREE = "3"
local COUNT_DOWN_FOUR = "4"
local COUNT_DOWN_FIVE = "5"
local COUNT_DOWN_SIX = "6"
local COUNT_DOWN_SEVRN = "7"
local COUNT_DOWN_EIGHT = "8"
local COUNT_DOWN_NIGHT = "9"

local RIGHT_SHOP_TIME_NUM1 = "right_shop_time_num1"
local RIGHT_SHOP_TIME_NUM2 = "right_shop_time_num2"
local RIGHT_SHOP_TIME_NUM3 = "right_shop_time_num3"
local RIGHT_SHOP_TIME_NUM4 = "right_shop_time_num4"

local LEFT_SHOP_TIME_NUM1 = "left_shop_time_num1"
local LEFT_SHOP_TIME_NUM2 = "left_shop_time_num2"
local LEFT_SHOP_TIME_NUM3 = "left_shop_time_num3"
local LEFT_SHOP_TIME_NUM4 = "left_shop_time_num4"
local COUNT_DOWN_DOUBLE_ZERO = "@assets:img/time/count_down_00.png"
local RIGHT_SHOP_TIME_NUM1_SIMILARITY = 85;

local BUFF_NUM_MIN_SIMILARITY = 50
local LEFT_SHOP_TIME_NUM2_SIMILARITY = {}
local LEFT_SHOP_TIME_NUM3_SIMILARITY = {}
--构建

local FIRST_BUFF_COUNT_DOWN_IMAGE_PATH_TABLE = {
    "@assets:img/time/count_down_0.png",
    "@assets:img/time/count_down_1.png",
    "@assets:img/time/count_down_2.png",
    "@assets:img/time/count_down_3.png",
    "@assets:img/time/count_down_4.png",
    "@assets:img/time/count_down_5.png",
    "@assets:img/time/count_down_6.png",
    "@assets:img/time/count_down_7.png",
    "@assets:img/time/count_down_8.png",
    "@assets:img/time/count_down_9.png"
}

local FIRST_BUFF_COUNT_DOWN_LEFT_SHOP_TABLE = {
    [LEFT_SHOP_TIME_NUM1] = LEFT_SHOP_TIME_NUM1_TABLE,
    [LEFT_SHOP_TIME_NUM2] = LEFT_SHOP_TIME_NUM2_TABLE,
    [LEFT_SHOP_TIME_NUM3] = LEFT_SHOP_TIME_NUM3_TABLE,
    [LEFT_SHOP_TIME_NUM4] = LEFT_SHOP_TIME_NUM4_TABLE
}

local FIRST_BUFF_COUNT_DOWN_RIGHT_SHOP_TABLE = {
    [RIGHT_SHOP_TIME_NUM1] = RIGHT_SHOP_TIME_NUM1_TABLE,
    [RIGHT_SHOP_TIME_NUM2] = RIGHT_SHOP_TIME_NUM2_TABLE,
    [RIGHT_SHOP_TIME_NUM3] = RIGHT_SHOP_TIME_NUM3_TABLE,
    [RIGHT_SHOP_TIME_NUM4] = RIGHT_SHOP_TIME_NUM4_TABLE
}

local BUFF_SWITCH_STATE_OPEN = 1
local BUFF_SWITCH_STATE_CLOSED = 2

local buffFirstCountDownOld
local isFirstBuffCountDown
local FIRST_BUFF_THIRTY_COUNT_DOWN
local NUM_MAX_CHECKTIME
local BUFF_EXIST_STATE_TIME
local NUM_RECHECK_INTERVAL
local NUM_LAST_CHECKTIME
local NUM_FIRST_CHECKTIME
local isFirstBuffThirtyCountDown
local isFirstStartCountDown
local FIRST_BUFF_UPDATE_TIME = 0

local RETRY_BUFF_COUNT = 3;
local retryBuffCount = 0
local BUFF_FIRST_COUNT_DOWN

local isInit = false
local mHerosPoint
local lastFullCover
local lastMapMode

local buffSwitch
local buffRemind
local buffCountDown

local redBuff
local blueBuff
local enemyRedBuff
local enemyBlueBuff

local TAG = "buff_script"
local function printLog(msg)
    commonlib_print(TAG, msg)
end

local function clearBuffSimilarityTableData()
    buffSimilarityTable = {};
end

local function convertBuffTimeSwitchStateToInt(isBuffCountDown)
    local buffTimeSwitchState = BUFF_SWITCH_STATE_OPEN
    if not isBuffCountDown then
        buffTimeSwitchState = BUFF_SWITCH_STATE_CLOSED
    end
    return buffTimeSwitchState
end

local function reportBuffTimeSwitchStatus()
    printLog("reportBuffTimeSwitchStatus=============================")
    local reportLib = Report();
    if reportLib ~= nil then
        reportLib:report({
            table_name = SGAME_ACCESSBILITY_SETTING_PAGES_TABLE,
            report_data = { skin = 0, battle = 0, enemy_nearby = 0, teammate = 0, enemy_disappear = 0, buff_time = convertBuffTimeSwitchStateToInt(isBuffCountDown) }
        })
    end
end

local function table_maxn(t)
    local value = 0
    local index = 0
    for k, v in pairs(t) do
        if value < v then
            value = v
            index = k
        end
    end
    return index, value
end

--- 获取图片的相似度
local function getImageSimilarity(imagePath, imageRect)
    local similarity = commonlib_recognizeMatchResource(imageRect, imagePath)
    if similarity == nil then
        return 0
    end
    return similarity
end

local function countDownTimeNum(shopTimeNum)
    local TIME_NUM_SIMILARITY = {}
    for i = 1, #FIRST_BUFF_COUNT_DOWN_IMAGE_PATH_TABLE do
        printLog("buff imagePath" .. FIRST_BUFF_COUNT_DOWN_IMAGE_PATH_TABLE[i])
        local numSimilarity = getImageSimilarity(FIRST_BUFF_COUNT_DOWN_IMAGE_PATH_TABLE[i], shopTimeNum)
        printLog("buff imagePathSimilarity" .. tostring(numSimilarity));
        table.insert(TIME_NUM_SIMILARITY, numSimilarity)
    end
    local timeNumMaxIndex, timeNumMax = table_maxn(TIME_NUM_SIMILARITY)
    printLog("buff imagePathmaxNum  " .. tostring(timeNumMaxIndex - 1))
    if timeNumMax < BUFF_NUM_MIN_SIMILARITY then
        timeNumMaxIndex = 0
    end
    return timeNumMaxIndex - 1;
end

local function countDownNum(num)
    return countDownTimeNum(num);
end

local function isCountDownNum(num1, num2)
    local countDownNumber2 = countDownNum(num2);
    printLog("buff num2 : " .. tostring(countDownNumber2))
    if countDownNumber2 ~= 0 then
        return false;
    end
    local countDownNumber1 = countDownNum(num1);
    printLog("buff num1 : " .. tostring(countDownNumber1))
    if countDownNumber1 ~= 0 then
        return false;
    end
    return true;
end

local function buffThirtyCountDown(num1, num2, num3, num4)
    local isNumDoubleZero = isCountDownNum(num1, num2);
    printLog("buff num Zero  " .. tostring(isNumDoubleZero))
    if not isNumDoubleZero then
        return nil;
    end
    local countDownNumber3 = countDownNum(num3);
    printLog("buff num3 : " .. tostring(countDownNumber3))
    if countDownNumber3 > 2 or countDownNumber3 == -1 then
        return nil;
    end
    local countDownNumber4 = countDownNum(num4);
    printLog("buff num4 : " .. tostring(countDownNumber4))

    if countDownNumber4 == -1 then
        return nil
    end
    printLog("buff num4 " .. tostring(countDownNumber4))
    local countDown = FIRST_BUFF_THIRTY_COUNT_DOWN - countDownNumber3 * 10 - countDownNumber4;
    printLog("buff num CountDown " .. tostring(countDown))
    return countDown;
end

local function leftShopFirstBuffThirtyCountDown()
    return buffThirtyCountDown(FIRST_BUFF_COUNT_DOWN_LEFT_SHOP_TABLE[LEFT_SHOP_TIME_NUM1], FIRST_BUFF_COUNT_DOWN_LEFT_SHOP_TABLE[LEFT_SHOP_TIME_NUM2],
        FIRST_BUFF_COUNT_DOWN_LEFT_SHOP_TABLE[LEFT_SHOP_TIME_NUM3], FIRST_BUFF_COUNT_DOWN_LEFT_SHOP_TABLE[LEFT_SHOP_TIME_NUM4])
end

local function rightShopFirstBuffThirtyCountDown()
    return buffThirtyCountDown(FIRST_BUFF_COUNT_DOWN_RIGHT_SHOP_TABLE[RIGHT_SHOP_TIME_NUM1], FIRST_BUFF_COUNT_DOWN_RIGHT_SHOP_TABLE[RIGHT_SHOP_TIME_NUM2],
        FIRST_BUFF_COUNT_DOWN_RIGHT_SHOP_TABLE[RIGHT_SHOP_TIME_NUM3], FIRST_BUFF_COUNT_DOWN_RIGHT_SHOP_TABLE[RIGHT_SHOP_TIME_NUM4])
end

local function firstBuffCountDown()
    --先判断是做出装还是又出装
    local shopPostion = commonlib_getGameParam(KEY_SHOP_MENU_POSITION)
    if shopPostion == nil then
        return
    end
    if shopPostion == SHOP_MENU_POSITION_LEFT then
        return leftShopFirstBuffThirtyCountDown()
    elseif shopPostion == SHOP_MENU_POSITION_RIGHT then
        return rightShopFirstBuffThirtyCountDown()
    end
end

local function loadHerosPoint()
    local t1 = commonlib_getCurrentTime()
    mHerosPoint = commonlib_recognizeFindObjectPosition(SMALL_MAP_RECOGNIZE_RECT);
    local t2 = commonlib_getCurrentTime()
    printLog("buff loadHerosPoint:" .. tostring((t2 - t1)))
end

local function hideBuffTimeRemind()
    if redBuff ~= nil then
        redBuff:hide();
    end
    if blueBuff ~= nil then
        blueBuff:hide();
    end
    if enemyRedBuff ~= nil then
        enemyRedBuff:hide();
    end
    if enemyBlueBuff ~= nil then
        enemyBlueBuff:hide();
    end
end


local function showBuffTimeRemind()
    if redBuff ~= nil then
        redBuff:show();
    end
    if blueBuff ~= nil then
        blueBuff:show();
    end
    if enemyRedBuff ~= nil then
        enemyRedBuff:show();
    end
    if enemyBlueBuff ~= nil then
        enemyBlueBuff:show();
    end
end

local function redBuffTimeRemindEnd()
    printLog("buff 结束红Buff倒计时");
    if redBuff ~= nil then
        redBuff:destroy();
        redBuff = nil;
    end
end

local function blueBuffTimeRemindEnd()
    printLog("buff 结束蓝Buff倒计时");
    if blueBuff ~= nil then
        blueBuff:destroy();
        blueBuff = nil;
    end
end

local function enemyRedBuffTimeRemindEnd()
    if enemyRedBuff ~= nil then
        enemyRedBuff:destroy();
        enemyRedBuff = nil;
    end
end

local function enemyBlueBuffTimeRemindEnd()
    printLog("buff 结束敌方蓝Buff倒计时");
    if enemyBlueBuff ~= nil then
        enemyBlueBuff:destroy();
        enemyBlueBuff = nil;
    end
end

local function addRedBuffTimeRemind(countDownTime)
    printLog("buff addRedBuffTimeRemind" .. tostring(countDownTime))
    local view = UnClickableFloatView();
    local anchor = Anchor();
    local zorder = ZOrder();
    if view == nil then
        printLog("UnClickableFloatView获取值为空");
    end
    redBuff = view:addTimeBuffRemindView(countDownTime, anchor.TOPLEFT,
        167, 225, zorder.zorder_top, redBuffTimeRemindEnd);
    redBuff:start();
end

local function addBlueBuffTimeRemind(countDownTime)
    printLog("buff addBlueBuffTimeRemind" .. tostring(countDownTime))
    local view = UnClickableFloatView();
    local anchor = Anchor();
    local zorder = ZOrder();
    if view == nil then
        printLog("UnClickableFloatView获取值为空");
    end
    blueBuff = view:addTimeBuffRemindView(countDownTime, anchor.TOPLEFT,
        81, 123, zorder.zorder_top, blueBuffTimeRemindEnd);
    blueBuff:start();
end

local function addEnemyRedBuffTimeRemind(countDownTime)
    printLog("buff addEnemyRedBuffTimeRemind" .. tostring(countDownTime))
    local view = UnClickableFloatView();
    local anchor = Anchor();
    local zorder = ZOrder();
    if view == nil then
        printLog("UnClickableFloatView获取值为空");
    end
    enemyRedBuff = view:addTimeBuffRemindView(countDownTime, anchor.TOPLEFT,
        154, 26, zorder.zorder_top, enemyRedBuffTimeRemindEnd);
    enemyRedBuff:start();
end

local function addEnemyBlueBuffTimeRemind(countDownTime)
    printLog("buff addEnemyBlueBuffTimeRemind" .. tostring(countDownTime))
    local view = UnClickableFloatView();
    local anchor = Anchor();
    local zorder = ZOrder();
    if view == nil then
        printLog("UnClickableFloatView获取值为空");
    end
    enemyBlueBuff = view:addTimeBuffRemindView(countDownTime, anchor.TOPLEFT,
        237, 128, zorder.zorder_top, enemyBlueBuffTimeRemindEnd);
    enemyBlueBuff:start();
end

local function addRedBuffTimeRemindThirty()
    printLog("buff countDownThirtyRedBuff" .. tostring(BUFF_FIRST_COUNT_DOWN))
    addRedBuffTimeRemind(BUFF_FIRST_COUNT_DOWN)
end

local function addBlueBuffTimeRemindThirty()
    printLog("buff countDownThirtydBlueBuff" .. tostring(BUFF_FIRST_COUNT_DOWN))
    addBlueBuffTimeRemind(BUFF_FIRST_COUNT_DOWN)
end

local function addEnemyRedBuffTimeRemindThirty()
    addEnemyRedBuffTimeRemind(BUFF_FIRST_COUNT_DOWN)
end

local function addEnemyBlueBuffTimeRemindThirty()
    printLog("buff countDownThirtyEnemyBlue" .. tostring(BUFF_FIRST_COUNT_DOWN))
    addEnemyBlueBuffTimeRemind(BUFF_FIRST_COUNT_DOWN)
end

local function addRedBuffTimeRemindNinety()
    addRedBuffTimeRemind(RED_BUFF_COUNT_DOWN_TIME)
end

local function addBlueBuffTimeRemindNinety()
    addBlueBuffTimeRemind(BLUE_BUFF_COUNT_DOWN_TIME)
end

local function addEnemyRedBuffTimeRemindNinety()
    addEnemyRedBuffTimeRemind(ENEMY_RED_BUFF_COUNT_DOWN_TIME)
end

local function addEnemyBlueBuffTimeRemindNinety()
    addEnemyBlueBuffTimeRemind(ENEMY_BLUE_BUFF_COUNT_DOWN_TIME)
end

local function addBuffTimeRemindNinetyInUIThread(type)
    printLog("buff addBuffTimeRemind");
    if type == BUFF_TYPE_RED then
        commonlib_runOnUIThread(addRedBuffTimeRemindNinety)
    elseif type == BUFF_TYPE_BULE then
        commonlib_runOnUIThread(addBlueBuffTimeRemindNinety)
    elseif type == BUFF_TYPE_ENEMY_RED then
        commonlib_runOnUIThread(addEnemyRedBuffTimeRemindNinety)
    elseif type == BUFF_TYPE_ENEMY_BLUE then
        commonlib_runOnUIThread(addEnemyBlueBuffTimeRemindNinety)
    end
end

local function addBuffTimeRemindThirtyInUIThread(type)
    printLog("buff addBuffTimeRemindThirtyInUIThread");
    if type == BUFF_TYPE_RED then
        commonlib_runOnUIThread(addRedBuffTimeRemindThirty)
    elseif type == BUFF_TYPE_BULE then
        commonlib_runOnUIThread(addBlueBuffTimeRemindThirty)
    elseif type == BUFF_TYPE_ENEMY_RED then
        commonlib_runOnUIThread(addEnemyRedBuffTimeRemindThirty)
    elseif type == BUFF_TYPE_ENEMY_BLUE then
        commonlib_runOnUIThread(addEnemyBlueBuffTimeRemindThirty)
    end
end

local function buffTimeRemindEndInUIThread(type)
    printLog("buff 结束" .. tostring(mBuffTag[type]) .. "倒计时在UI线程");
    if type == BUFF_TYPE_RED then
        if redBuff ~= nil then
            commonlib_runOnUIThread(redBuffTimeRemindEnd)
        end
    elseif type == BUFF_TYPE_BULE then
        if blueBuff ~= nil then
            commonlib_runOnUIThread(blueBuffTimeRemindEnd)
        end
    elseif type == BUFF_TYPE_ENEMY_RED then
        if enemyRedBuff ~= nil then
            commonlib_runOnUIThread(enemyRedBuffTimeRemindEnd)
        end
    elseif type == BUFF_TYPE_ENEMY_BLUE then
        if enemyBlueBuff ~= nil then
            commonlib_runOnUIThread(enemyBlueBuffTimeRemindEnd)
        end
    end
end

local function setThirtyCountDownBuffState()
    if isFirstBuffThirtyCountDown then
        printLog("bufffirstBuffCount BuffState true")
        for key, rect in pairs(mBuffRectTable) do
            buffTimeRemindEndInUIThread(key)
            mBuffCachedStateRecordTime[key] = commonlib_getCurrentTime()
        end
    end
end

local function reportBuffCountDownRemind()
    printLog("reportBuffCountDownRemind===================================");
    local reportLib = Report();
    if reportLib ~= nil then
        reportLib:report({
            table_name = SGAME_ACCESSBILITY_REMIND_INFO,
            report_data = { remind_strategy = REMIND_STRATEGY_BUFF_TIME }
        })
    end
end

local function setBuffState(type, state)
    printLog("setBuffState");
    mBuffCachedStatus[type] = state;
end

-- 将Buff存在状态置1
local function prepareBuffCountDown(type)
    setBuffState(type, BUFF_STATE_EXIST)
    mBuffCachedStateRecordTime[type] = commonlib_getCurrentTime()
    mIsBuffCachedStateAvail[type] = true
end

local function resetCountDownState(type)
    buffTimeRemindEndInUIThread(type)
    mBuffCachedStateRecordTime[type] = commonlib_getCurrentTime()
    mIsBuffCountDownRunning[type] = false
end

local function startBuffCountDown(type, isFirstBuff)
    mBuffCountDownStartTime[type] = commonlib_getCurrentTime()
    if isFirstBuff then
        addBuffTimeRemindThirtyInUIThread(type);
    else
        addBuffTimeRemindNinetyInUIThread(type);
    end
    mIsBuffCountDownRunning[type] = true
    setBuffState(type, BUFF_STATE_UNKNOW)
--    reportBuffCountDownRemind()
end

local function startBuffNinetyCountDown(type)
    startBuffCountDown(type, false)
end

local function startBuffThirtyCountDown(type)
    startBuffCountDown(type, true)
end

local function isBuffCountDownReady(type)
    printLog("buff mBuffCachedStatus[type]" .. tostring(mBuffCachedStatus[type]) .. "mIsBuffCountDownRunning" .. tostring(mIsBuffCountDownRunning[type]))
    return (mBuffCachedStatus[type] == BUFF_STATE_EXIST) and not mIsBuffCountDownRunning[type]
end

local function isBuffCachedStateNotAvailable(type)
    return mBuffCachedStatus[type] ~= BUFF_STATE_EXIST or not mIsBuffCachedStateAvail[type]
end

local function isBuffCountDownJustFinished(buffStartTime, countDownTime)
    return commonlib_getCurrentTime() - buffStartTime >= countDownTime
            and commonlib_getCurrentTime() - buffStartTime <= countDownTime + 500
end

local function isBuffNinetyCountDownJustFinished(buffStartTime)
    return isBuffCountDownJustFinished(buffStartTime, BUFF_COUNT_DOWN_TIME)
end

local function isBuffThirtyCountDownJustFinished(buffStartTime, countDownTime)
    return isBuffCountDownJustFinished(buffStartTime, countDownTime)
end

local function setBuffThrityCountDownRunningState(isFirstBuffThirtyCountDown)
    printLog("buff setBuffThrityCountDownRunningState")
    if isFirstBuffThirtyCountDown then
        for key, rect in pairs(mBuffRectTable) do
            mIsBuffCountDownRunning[key] = false
        end
    end
end

local function updateBuffCountDownState(type, countDownTime)
    local times = commonlib_getCurrentTime() - mBuffCountDownStartTime[type];
    printLog("bufffirstBuffCount: " .. tostring(countDownTime) .. "times  " .. tostring(times));
    if (mIsBuffCountDownRunning[type] and commonlib_getCurrentTime() - mBuffCountDownStartTime[type] >= (countDownTime + FIRST_BUFF_UPDATE_TIME)) then
        printLog("bufffirstBuffCount updateBuff");
        mIsBuffCountDownRunning[type] = false
        mBuffCachedStateRecordTime[type] = 0
        setBuffThrityCountDownRunningState(isFirstBuffThirtyCountDown)
        isFirstBuffThirtyCountDown = false;
    end
    printLog("更新" .. tostring(mBuffTag[type]) .. "倒计时状态===After====" .. tostring(mIsBuffCountDownRunning[type]));
end

local function updateBuffNinetyCountDownState(type)
    updateBuffCountDownState(type, BUFF_COUNT_DOWN_TIME)
end

local function updateBuffThirtyCountDownState(type, countDownTime)
    updateBuffCountDownState(type, countDownTime)
end

local function isHeroNearbyBuff(buffCenterX, buffCenterY, heroNearbyBuffDistance)
    if mHerosPoint == nil then
        printLog("findObjectPosition 返回为nil");
        return false;
    end
    for index, hero in pairs(mHerosPoint) do
        -- printLog("hero type" .. tostring(hero.type) .. "distabceX: " .. tostring(hero.pos_x - buffCenterX) .. "distabceY: " .. tostring(hero.pos_y - buffCenterY) .. "heroNearbyBuffDistance" .. tostring(heroNearbyBuffDistance));
        if (math.abs(hero.pos_x - buffCenterX) <= heroNearbyBuffDistance) and (math.abs(hero.pos_y - buffCenterY) <= heroNearbyBuffDistance) then
            return true;
        end
    end
    return false;
end

local function isHeroNearbyBuffForeach(type)
    local isHeroNearRedBuff = isHeroNearbyBuff(mBuffRectCenterPointTable[type].x, mBuffRectCenterPointTable[type].y, HERO_NEARBY_BUFF_DISTANCE);
    printLog("英雄在" .. tostring(mBuffTag[type]) .. "附近：" .. tostring(isHeroNearRedBuff));
    return isHeroNearRedBuff;
end

local function updateBuffCachedStateAvailState(type)
    printLog("buff 更新" .. tostring(mBuffTag[type]) .. "状态1缓存状态====Before====Type:" .. tostring(type) .. "  " .. tostring(mIsBuffCachedStateAvail[type]));
    if not isHeroNearbyBuffForeach(type) and commonlib_getCurrentTime() - mBuffCachedStateRecordTime[type] >= BUFF_AVAIL_TIME then
        mIsBuffCachedStateAvail[type] = false
        printLog("bufffirstBuffCount avail  " .. tostring(type) .. "BUFF_STATE_UNKNOW")
        mBuffCachedStatus[type] = BUFF_STATE_UNKNOW
    end
    printLog("更新" .. tostring(mBuffTag[type]) .. "状态1缓存状态====Before====" .. tostring(mIsBuffCachedStateAvail[type]));
end

local function isBuffExisted(buffRect, buffMinSimilarity, type)
    local buffSimilarity = commonlib_recognizeMatchRedBlueBuffer(buffRect);
    buffSimilarityTable[type] = buffSimilarity;
    printLog("buff Similarity============  " .. tostring(buffSimilarityTable[type]));
    if buffSimilarity >= buffMinSimilarity then
        return true;
    else
        return false;
    end
end

local function isBuffExistedForeach(type)
    local isBuffExisted = isBuffExisted(mBuffRectTable[type], BUFF_MIN_SIMILARITY, type);
    printLog("buff " .. tostring(mBuffTag[type]) .. "图标是否存在：" .. tostring(isBuffExisted));
    return isBuffExisted;
end

local function isHeroFullCoveredBuffBySimilality(type)
    if not buffSimilarityTable then
        return false;
    end
    local buffSimilarityType = buffSimilarityTable[type];
    printLog("buffSimilarityType:  " .. tostring(buffSimilarityType))

    if buffSimilarityType > 0 and buffSimilarityType < BUFF_MIN_SIMILARITY then
        printLog("buffSimilarityType:  true")
        return true;
    end
end

local function isHeroFullCoveredBuff(type)
    local isHeroCoveredRedBuff = isHeroNearbyBuff(mBuffRectCenterPointTable[type].x, mBuffRectCenterPointTable[type].y, HERO_COVERED_BUFF_DISTANCE);
    printLog("英雄覆盖了" .. tostring(mBuffTag[type]) .. "：" .. tostring(isHeroCoveredRedBuff));
    local isCover = isHeroFullCoveredBuffBySimilality(type);
    printLog("英雄覆盖了  isCover :" .. tostring(isCover));
    return isHeroCoveredRedBuff or isCover;
end

local function addCountDownImage()
    commonlib_recognizeAddImage(COUNT_DOWN_DOUBLE_ZERO)
    for i = 1, #FIRST_BUFF_COUNT_DOWN_IMAGE_PATH_TABLE do
        commonlib_recognizeAddImage(FIRST_BUFF_COUNT_DOWN_IMAGE_PATH_TABLE[i]);
    end
end

local function isExitFirstThirtyBuffCountDown()
    local currentTime = commonlib_getCurrentTime()
    if not NUM_FIRST_CHECKTIME then
        NUM_FIRST_CHECKTIME = currentTime
    end
    if currentTime - NUM_FIRST_CHECKTIME > NUM_MAX_CHECKTIME then
        isFirstBuffCountDown = false
        return true;
    end
end

local function getFirstBuffCountDownTime()
    local firstBuffCountDownTime
    if isFirstBuffCountDown then
        printLog("buff num isFirstBuffCountDown")
        local currentTime = commonlib_getCurrentTime()
        local isExitFirstBuffCountDown = isExitFirstThirtyBuffCountDown();
        if isExitFirstBuffCountDown then
            return
        end

        if currentTime - NUM_LAST_CHECKTIME > NUM_RECHECK_INTERVAL then
            firstBuffCountDownTime = firstBuffCountDown();
            if not firstBuffCountDownTime then
                printLog("buff num NUM_LAST_CHECKTIME")
                NUM_LAST_CHECKTIME = currentTime
                return
            end
            printLog("buff num start" .. tostring(firstBuffCountDownTime))
            if buffFirstCountDownOld ~= firstBuffCountDownTime then
                buffFirstCountDownOld = firstBuffCountDownTime
                isFirstBuffCountDown = false;
            else
                NUM_LAST_CHECKTIME = currentTime
                return
            end
        end
    end
    return firstBuffCountDownTime
end

local function firstBuffThirtyCountDown(type)
    local firstBuffCountDownTime = getFirstBuffCountDownTime();
    if not firstBuffCountDownTime then
        return
    end
    local isExitFirstBuffCountDown = isExitFirstThirtyBuffCountDown();
    if isExitFirstBuffCountDown then
        updateBuffThirtyCountDownState(type, BUFF_FIRST_COUNT_DOWN)
        return
    end
    isFirstBuffCountDown = false;
    BUFF_FIRST_COUNT_DOWN = firstBuffCountDownTime * 1000;
    printLog("buff num end:" .. tostring(firstBuffCountDownTime))
    local isBuffCountDownRunning = mIsBuffCountDownRunning[type]
    printLog("bufffirstBuffCount running" .. tostring(isBuffCountDownRunning) .. "type : " .. tostring(type) .. " isFirstStartCountDown : " .. tostring(isFirstStartCountDown))
    if not isBuffCountDownRunning and isFirstStartCountDown then
        printLog("buff num start buffCountDown: " .. tostring(BUFF_FIRST_COUNT_DOWN))
        for key, rect in pairs(mBuffRectTable) do
            startBuffThirtyCountDown(key)
        end
        isFirstStartCountDown = false
    end
    local countDownTime = BUFF_FIRST_COUNT_DOWN - BUFF_EXIST_STATE_TIME;
    local isBuffThirtyCountDown = isBuffThirtyCountDownJustFinished(mBuffCountDownStartTime[type], countDownTime)
    printLog("bufffirstBuffCount   --" .. tostring(isBuffThirtyCountDown));
    if isBuffThirtyCountDown then
        printLog("bufffirstBuffCount 设置状态为1" .. tostring(type));
        for key, rect in pairs(mBuffRectTable) do
            printLog("bufffirstBuffCount" .. tostring(key));
            prepareBuffCountDown(key)
        end
    end
    updateBuffThirtyCountDownState(type, BUFF_FIRST_COUNT_DOWN)
end

local function buffRefreshCountDownForeach(type)
    --printLog("buff Pre====== " .. tostring(mBuffTag[type]) .. "倒计时===============");

    if not isBuffExistedForeach(type) then
        local mIsHeroFullCoveredBuff = isHeroFullCoveredBuff(type)
        printLog("buff mIsHeroFullCoveredBuff()" .. tostring(mIsHeroFullCoveredBuff));
        if not mIsHeroFullCoveredBuff then
            if isBuffCountDownReady(type) then
                printLog("buff 开始" .. tostring(mBuffTag[type]) .. "倒计时");
                startBuffNinetyCountDown(type)
            end
        else
            if isBuffNinetyCountDownJustFinished(mBuffCountDownStartTime[type]) then
                printLog("" .. tostring(mBuffTag[type]) .. "倒计时刚好结束，设置状态为1");
                setBuffState(type, BUFF_STATE_EXIST)
            end
        end
    else
        printLog("" .. mBuffTag[type] .. "图标存在");
        if isHeroNearbyBuffForeach(type) then
            printLog("buff 队友在" .. tostring(mBuffTag[type]) .. "附近");
            if isBuffCachedStateNotAvailable(type) then
                printLog("buff 队友在" .. tostring(mBuffTag[type]) .. "附近，设置状态为1");
                prepareBuffCountDown(type)
            end
        end

        if mIsBuffCountDownRunning[type] then
            printLog("buff 已有倒计时，停止倒计时");
            resetCountDownState(type)
        end
--        setThirtyCountDownBuffState()
    end

    if isHeroNearbyBuffForeach(type) and mIsBuffCachedStateAvail[type] then
        mBuffCachedStateRecordTime[type] = commonlib_getCurrentTime()
    end

    updateBuffNinetyCountDownState(type)
    updateBuffCachedStateAvailState(type)
end

local function buffCountDownForeach()
    for key, rect in pairs(mBuffRectTable) do
        if isFirstBuffThirtyCountDown then
            firstBuffThirtyCountDown(key)
        end
        buffRefreshCountDownForeach(key)
    end
end

local function destroyBuffTimeRemind()
    printLog("destroyBuffTimeRemind ")
    if GAME_STATE_FINISH == commonlib_getGameParam(KEY_GAME_STATE) then
        for key, rect in pairs(mBuffRectTable) do
            buffTimeRemindEndInUIThread(key)
        end
    end
end

local function initBuffCenterPoint()
    for key, rect in pairs(mBuffRectTable) do
        printLog("=========================rect:" .. tostring(rect))
        mBuffRectCenterPointTable[key].x = rect.left + rect.width / 2
        mBuffRectCenterPointTable[key].y = rect.top + rect.height / 2
    end
end

--- 判断设置项中Buff倒计时的checkbox是否被选中
local function isBuffCountDownChecked()
    printLog("isBuffCountDownChecked");
    if buffCountDown == nil then
        return false;
    end

    if buffCountDown:isChecked() then
        return true;
    end
end

--- 控件点击或者选中的回调函数
local function onCheckboxSelected(id)
    printLog("控件回调" .. tostring(id));
    if buffSwitch == nil or buffCountDown == nil then
        printLog("控件为空");
    end

    if id == buffSwitch:getId() then
        if not buffSwitch:isChecked() then
            buffCountDown:setChecked(false);
            isBuffCountDown = false;
            commonlib_setSharedPrefBoolean(KEY_IS_BUFF_CHECKED, false)
        else
            buffCountDown:setChecked(true);
            isBuffCountDown = true;
            commonlib_setSharedPrefBoolean(KEY_IS_BUFF_CHECKED, true)
        end
    end
    if id == buffCountDown:getId() then
        if buffCountDown:isChecked() then
            isBuffCountDown = true;
        else
            isBuffCountDown = false;
        end
    end
end

--- 初始化Buff设置页面UI函数
local function initBuffSettingUI()
    local isSwitchChecked = commonlib_getSharedPrefBoolean(KEY_IS_BUFF_CHECKED, true)
    printLog("initBuffSettingUI begin")
    local settingView = SettingView()
    local settingPanel = settingView:addTableView(SETTING_PANEL_NAME)

    local buffParam;
    local buffParams;

    buffParam = create("RelativeLayoutParam");
    buffParams = {
        layout_marginTop = "10dp",
        layout_marginLeft = "10dp"
    }
    buffParam:setLayoutParam(buffParams);
    buffSwitch = settingPanel:addCheckBoxView(BUFF_SWITCH_TEXT, isSwitchChecked, buffParam, onCheckboxSelected);

    buffParam = create("RelativeLayoutParam");
    buffParams = {
        layout_below = buffSwitch:getId(),
        layout_marginTop = "20dp",
        layout_marginLeft = "25dp"
    }
    buffParam:setLayoutParam(buffParams);
    buffCountDown = settingPanel:addCheckBoxView(BUFF_COUNT_DOWN_TEXT, isSwitchChecked, buffParam, onCheckboxSelected);
end

--- 设置面板UI相关
local function initConfigUI()
    if not isInit then
        initBuffSettingUI();
        isBuffCountDown = isBuffCountDownChecked();
        printLog("isBuffCountDown" .. tostring(isBuffCountDown))
        isInit = true
    end
end

local function initData()
    buffFirstCountDownOld = 21
    isFirstBuffCountDown = true
    FIRST_BUFF_THIRTY_COUNT_DOWN = 30
    NUM_MAX_CHECKTIME = 30000
    BUFF_EXIST_STATE_TIME = 3000
    NUM_RECHECK_INTERVAL = 1000
    NUM_LAST_CHECKTIME = 0
    NUM_FIRST_CHECKTIME = nil
    isFirstBuffThirtyCountDown = true
    isFirstStartCountDown = true
    FIRST_BUFF_UPDATE_TIME = 2000
end

local function onGameRunning()
    if isBuffCountDown and not commonlib_isFullCoverOrMapExpand(lastFullCover, lastMapMode) then
        loadHerosPoint();
        buffCountDownForeach();
        clearBuffSimilarityTableData()
    end
end

local function onGameOver()
    printLog("onGameOver")
    if isBuffCountDown then
        destroyBuffTimeRemind()
    end
end

local function onJustEnterGame()
    printLog("onJustEnterGame")
    initData()
--    reportBuffTimeSwitchStatus()
end

local function onFullCoverStateChange(isFullCover)
    printLog("onFullCoverStateChanged isFullCover: " .. tostring(isFullCover))
    if isBuffCountDown then
        lastFullCover = isFullCover
        commonlib_runOnUIThread(function()
            if isFullCover then
                hideBuffTimeRemind()
            else
                showBuffTimeRemind()
            end
        end)
    end
end

local function onMapModeChange(mapMode)
    printLog("onMapModeChanged mapMode: " .. tostring(mapMode))
    if isBuffCountDown then
        lastMapMode = mapMode
        commonlib_runOnUIThread(function()
            if mapMode == LARGE_MAP_LEFT_ZOOMOUT or mapMode == LARGE_MAP_RIGHT_ZOOMOUT then
                printLog("isMapExpand 小地图展开")
                hideBuffTimeRemind()
            else
                showBuffTimeRemind()
            end
        end)
    end
end

local function registerGameEvents()
    commonlib_registerCallback(common_game_events_callbacks.common_just_enter_game, onJustEnterGame)
    commonlib_registerCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_registerCallback(common_game_events_callbacks.common_full_cover, onFullCoverStateChange)
    commonlib_registerCallback(common_game_events_callbacks.common_map_mode, onMapModeChange)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks.common_just_enter_game, onJustEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_unregisterCallback(common_game_events_callbacks.common_full_cover, onFullCoverStateChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_map_mode, onMapModeChange)
end

--- 初始化与反初始化
local function init()
    printLog("init")
    registerGameEvents()
    lastFullCover = false
    lastMapMode = nil

    initBuffCenterPoint()
    addCountDownImage()
    initConfigUI()
end

local function uninit()
    printLog("uninit")
    isInit = false
    lastFullCover = false
    lastMapMode = nil

    redBuff = nil
    blueBuff = nil
    enemyRedBuff = nil
    enemyBlueBuff = nil

    if buffSwitch ~= nil then
        buffSwitch = nil
    end

    if buffCountDown ~= nil then
        buffCountDown = nil
    end
    unregisterGameEvents()
end

table.insert(common_life_circle_callbacks, { init, uninit })