--- 确定游戏状态的脚本

-- 识别信息表，包含对比图片路径和识别信息
-- 每一个识别信息（reconnizeTable）包含三个部分: path : 参考图片路径  rect : 识别区域  threshold : 相似度
-- 游戏状态
local GAME_STATE_RECOGNIZE_TABLE = {
    [GAME_STATE_LOADING] = {
        { path = "@assets:img/commonstate/refer_loading.png", rect = { flag = Anchor().CENTER, left = -130, top = -60, width = 259, height = 120 }, threshold = 70 }
    },
    [GAME_STATE_FINISH] = {
        { path = "@assets:img/commonstate/refer_victory.png", rect = { flag = Anchor().CENTER, left = -193, top = -40, width = 389, height = 132 }, threshold = 70 },
        { path = "@assets:img/commonstate/refer_defeat.png", rect = { flag = Anchor().CENTER, left = -177, top = -58, width = 163, height = 161 }, threshold = 70 }
    }
}

-- 不可变元素识别信息表
-- 是否在5v5地图中
-- S9 赛季第一张5v5地图水晶
local S9_5V5_MAP_1_RECOGNIZE_INFO = { path = "@assets:img/commonstate/refer_5v5map_1.png", rect = { flag = Anchor().TOPLEFT, left = 294, top = 16, width = 28, height = 32 }, threshold = 70 }
-- S9 赛季第二张5v5地图水晶
local S9_5V5_MAP_2_RECOGNIZE_INFO = { path = "@assets:img/commonstate/refer_5v5map_2.png", rect = { flag = Anchor().TOPLEFT, left = 295, top = 17, width = 28, height = 32 }, threshold = 70 }

-- 是否有设置按钮
local HAS_SETTING_BUTTON_RECOGNZIE_TABLE = {
    { path = "@assets:img/commonstate/refer_setting_button.png", rect = { flag = Anchor().TOPRIGHT, left = -73, top = 9, width = 61, height = 61 }, threshold = 70 },
    { path = "@assets:img/commonstate/refer_setting_button.png", rect = { flag = Anchor().TOPRIGHT, left = -215, top = 22, width = 61, height = 61 }, threshold = 70 }
}
-- 是否有暂停按钮
local HAS_PAUSE_BUTTON_RECOGNIZE_TABLE = {
    { path = "@assets:img/commonstate/refer_pause_button.png", rect = { flag = Anchor().TOPLEFT, left = 307, top = 405, width = 29, height = 30 }, threshold = 70 },
    { path = "@assets:img/commonstate/refer_pause_button.png", rect = { flag = Anchor().TOPRIGHT, left = -142, top = 122, width = 29, height = 30 }, threshold = 70 }
}
-- 四技能英雄
local FOUR_SKILL_HERO_RECOGNIZE_TABLE = {
    { path = "@assets:img/commonstate/refer_four_skill_hero_daqiao.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -190, top = -507, width = 113, height = 111 }, threshold = 90 },
    --- 芈月技能与干将的相似度很高，为避免重复将干将的阀值调高
    { path = "@assets:img/commonstate/refer_four_skill_hero_ganjiang.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -190, top = -507, width = 113, height = 111 }, threshold = 90 },
}
-- 召唤技能圈
local SUMMONER_SKILL_COUNT_RECOGNIZE_TABLE = {
    -- 第三个圈的位置
    THIRD_SKILL_POSITION = { path = "@assets:img/commonstate/refer_summoner_skill_count.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -1010, top = -174, width = 124, height = 124 }, threshold = 90 },
    -- 第四个圈的位置(只加载一次)
    FORTH_SKILL_POSITION = { path = "@assets:img/commonstate/refer_summoner_skill_count.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -1153, top = -174, width = 124, height = 124 }, threshold = 90 },
}

-- 可变元素识别信息表
-- 英雄攻击模式
local HERO_ATTACK_MODE_RECOGNIZE_TALBE = {
    [HERO_ATTACK_MODE_ADVANCED_FREE] = { path = "@assets:img/commonstate/refer_hero_attack_mode_advanced_free.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -132, top = -366, width = 102, height = 102 }, threshold = 90 },
    [HERO_ATTACK_MODE_LOCK] = { path = "@assets:img/commonstate/refer_hero_attack_mode_lock.png", rect = { flag = Anchor().BOTTOMRIGHT, left = -76, top = -187, width = 69, height = 82 }, threshold = 90 }
}
-- 商店菜单位置
local SHOP_MENU_POSITION_RECOGNIZE_TABLE = {
    [SHOP_MENU_POSITION_LEFT] = { path = "@assets:img/commonstate/refer_shop_menu_position_left.png", rect = { flag = Anchor().LEFT, left = 43, top = -138, width = 58, height = 68 }, threshold = 70 },
    [SHOP_MENU_POSITION_RIGHT] = { path = "@assets:img/commonstate/refer_shop_menu_position_right.png", rect = { flag = Anchor().TOPRIGHT, left = -92, top = 8, width = 45, height = 45 }, threshold = 70 },
}

-- 半遮挡
-- 聊天窗口是否打开
local CHAT_WINDOW_RECOGNIZE_INFO = { path = "@assets:img/commonstate/refer_is_chat_window_open.png", rect = { flag = Anchor().TOPRIGHT, left = -156, top = 707, width = 130, height = 47 }, threshold = 70 }
-- 小地图
local SMALL_MAP_RECOGNIZE_TABLE = {
    [LARGE_MAP_HIDE] = { path = "@assets:img/commonstate/refer_large_map_hide.png", rect = { flag = Anchor().TOPLEFT, left = 345, top = 282, width = 72, height = 72 }, threshold = 70 },
    [LARGE_MAP_LEFT_ZOOMOUT] = { path = "@assets:img/commonstate/refer_large_map_state.png", rect = { flag = Anchor().TOPLEFT, left = 874, top = 692, width = 85, height = 85 }, threshold = 70 },
    [LARGE_MAP_RIGHT_ZOOMOUT] = { path = "@assets:img/commonstate/refer_large_map_state.png", rect = { flag = Anchor().TOPRIGHT, left = -964, top = 740, width = 85, height = 85 }, threshold = 70 }
}

-- 输入法
local INPUT_METHOD_RECOGNIZE_INFO = {
    path = "@assets:img/commonstate/refer_input_method.png",
    rect = { flag = Anchor().BOTTOMRIGHT, left = -338, top = -172, width = 76, height = 100 },
    threshold = 70
}

-- 其它
-- 设置窗口是否打开
local SETTING_WINDOW_RECOGNIZE_INFO = { path = "@assets:img/commonstate/refer_is_setup_window_open.png", rect = { flag = Anchor().LEFT, left = 41, top = -444, width = 120, height = 59 }, threshold = 70 }

-- 识别5v5地图的次数
local RECOGNIZE_5V5_MAP_COUNT = 25

-- 重试识别的时长
local RETRY_RECOGNIZE_DURATION = 6 * 1000;

local SHOP_MENU_POSITION_TYPE_LEFT = 1
local SHOP_MENU_POSITION_TYPE_RIGHT = 2
local SHOP_MENU_POSITION_TYPE_UNKNOW = 3
local HERO_ATTACK_MODE_TYPE_RREE = 1
local HERO_ATTACK_MODE_TYPE_ADVANCED_FREE = 2
local HERO_ATTACK_MODE_TYPE_LOCK = 3
local HERO_ATTACK_MODE_TYPE_UNKNOWN = 4

local COMMON_LOG = "common_state"
local INIT_INDEX = 1
local UNINIT_INDEX = 2

local enterGameTime = 0
local lastState -- 上一个时刻的游戏状态
local lastIsIn5v5Map = false
local shouldUpdateAlterableElement

local globalGameConfig

-- 游戏状态
local tvGameState

-- 不可变元素
local tvIsIn5v5Map
local tvHeroSkillCount
local tvSummonerSkillCount

-- 可变元素
local tvShopMenuPosition
local tvHeroAttackMode

-- 遮挡
local tvIsInFullCover
local tvLargeMapState
local tvIsChatWindowOpen

local lastIsFullCover
local lastIsChatOpen
local lastLargeMap
local lastEquipment
local lastAttackMode
local isGameStartCalled
local hasReportLoadingData = false;
local hasReportFloatWindowData = false;

local function printLog(msg)
    commonlib_print(COMMON_LOG, msg)
end

local function setState(key, value)
    if globalGameConfig ~= nil and key ~= nil and value ~= nil then
        globalGameConfig:set(key, value)
        printLog("setState : " .. tostring(key) .. " = " .. tostring(value))
    else
        printLog("setState params is nil")
    end
end

local function getState(key)
    if globalGameConfig ~= nil and key ~= nil then
        return globalGameConfig:get(key)
    end
    printLog("getState params is nil")
    return nil
end

---------------------------------- 埋点上报 ------------------------------------------------
local SGAME_ACCESSBILITY_FLOAT_ENTRANCE = "cm_cn_tmgp_sgame_accessbility_float_entrance"
local GAMEMASTER_GAME_ASSISTANT_SRV = "gamemaster_game_assistant_srv"
local REPORT_SHOW_LOADING_VIEW = 3;
local REPORT_SHOW_NOT_FLOAT_WINDOW_VIEW = 2;

local function isJustEnterGame()
    return commonlib_getGameParam(KEY_IS_JUST_ENTER_GAME)
end

local function convertMoneyAreaToInt(money_area)
    local moneyArea = SHOP_MENU_POSITION_TYPE_UNKNOW
    if money_area == SHOP_MENU_POSITION_LEFT then
        moneyArea = SHOP_MENU_POSITION_TYPE_LEFT
    elseif money_area == SHOP_MENU_POSITION_RIGHT then
        moneyArea = SHOP_MENU_POSITION_TYPE_RIGHT
    end
    return moneyArea
end

local function convertAttackPatternToInt(attack_pattern)
    printLog("AttackPattern===================" .. "埋点测试" .. tostring(attack_pattern));
    local heroAttackPattern = HERO_ATTACK_MODE_TYPE_UNKNOWN
    if attack_pattern == HERO_ATTACK_MODE_FREE then
        heroAttackPattern = HERO_ATTACK_MODE_TYPE_RREE
    elseif attack_pattern == HERO_ATTACK_MODE_ADVANCED_FREE then
        heroAttackPattern = HERO_ATTACK_MODE_TYPE_ADVANCED_FREE
    elseif attack_pattern == HERO_ATTACK_MODE_LOCK then
        heroAttackPattern = HERO_ATTACK_MODE_TYPE_LOCK
    end
    return heroAttackPattern
end

local function reportMoneyAreaAndAttackPattern()
    printLog("reportMoneyAreaAndAttackPattern ==================================");
    local reportLib = Report();
    if reportLib ~= nil then
        local moneyArea = convertMoneyAreaToInt(getState(KEY_SHOP_MENU_POSITION))
        local attackPattern = convertAttackPatternToInt(getState(KEY_HERO_ATTACK_MODE))
        reportLib:report({
            table_name = SGAME_ACCESSBILITY_FLOAT_ENTRANCE,
            report_data = { entrance = 0, money_area = moneyArea, attack_pattern = attackPattern }
        })
    end
end

----------------------------------------- 表处理相关的函数-------------------------------------------
local function handleTableWithoutParam(srcTable)
    for i = 1, #srcTable do
        if srcTable[i] ~= nil then
            srcTable[i]()
        end
    end
end

local function handleTableWithBoolParam(srcTable, boolValue)
    for i = 1, #srcTable do
        if srcTable[i] ~= nil then
            srcTable[i](boolValue)
        end
    end
end

local function handleTableWithStringParam(srcTable, stringValue)
    for i = 1, #srcTable do
        if srcTable[i] ~= nil then
            srcTable[i](stringValue)
        end
    end
end

local function handleNestingTable(srcTable, index)
    for i = 1, #srcTable do
        if srcTable[i] ~= nil and srcTable[i][index] ~= nil then
            srcTable[i][index]()
        end
    end
end

local function shouldCallGameEventsCallbacks()
    if getState(KEY_GAME_STATE) ~= GAME_STATE_RUNNING then
        return false
    end

    if getState(KEY_HAS_PAUSE_BUTTON) then
        return false
    end

    if not getState(KEY_HAS_SETTING_BUTTON) then
        return false
    end

    if not getState(KEY_IS_IN_5V5_MAP) then
        return false
    end

    return true
end

--------------------------------------- 生命周期相关的回调函数---------------------------------------
local function callLifeCircleInit()
    --printLog("callLifeCircleInit begin")
    if commonlib_isTableEmpty(common_life_circle_callbacks) then
        printLog("callLifeCircleInit common_life_circle_callbacks is nil or empty")
        return
    end
    handleNestingTable(common_life_circle_callbacks, INIT_INDEX)
end

local function callLifeCircleUninit()
    --printLog("callLifeCircleUninit begin")
    if commonlib_isTableEmpty(common_life_circle_callbacks) then
        printLog("callLifeCircleUninit common_life_circle_callbacks is nil or empty")
        return
    end
    handleNestingTable(common_life_circle_callbacks, UNINIT_INDEX)
end

--------------------------------------- 游戏事件相关的回调函数---------------------------------------
local function callGameLoadingCallback()
    --printLog("callGameLoadingCallback begin")
    if commonlib_isTableEmpty(common_game_events_callbacks.common_game_loading) then
        printLog("callGameLoadingCallback common_game_loading table is nil or empty")
        return
    end
    handleTableWithoutParam(common_game_events_callbacks.common_game_loading)
end

local function callJustEnterGameCallback()
    --printLog("callJustEnterGameCallback begin")
    if commonlib_isTableEmpty(common_game_events_callbacks.common_just_enter_game) then
        printLog("callJustEnterGameCallback common_just_enter_game table is nil or empty")
        return
    end
    handleTableWithoutParam(common_game_events_callbacks.common_just_enter_game)
end

local function callGameStartCallback()
    --printLog("callGameStartCallback begin")
    if commonlib_isTableEmpty(common_game_events_callbacks.common_game_start) then
        printLog("callGameStartCallback common_game_start table is nil or empty")
        return
    end
    handleTableWithoutParam(common_game_events_callbacks.common_game_start)
end

local function callGameRunningCallback()
    --printLog("callGameRunningCallback begin")
    if commonlib_isTableEmpty(common_game_events_callbacks.common_game_running) then
        printLog("callGameRunningCallback common_game_running table is nil or empty")
        return
    end
    handleTableWithoutParam(common_game_events_callbacks.common_game_running)
end

local function callGameOverCallback()
    --printLog("callGameOverCallback begin")
    if commonlib_isTableEmpty(common_game_events_callbacks.common_game_over) then
        printLog("callGameOverCallback common_game_over table is nil or empty")
        return
    end
    handleTableWithoutParam(common_game_events_callbacks.common_game_over)
end

local function callFullCoverCallback(isFullCover)
    --printLog("callFullCoverCallback begin")
    if commonlib_isTableEmpty(common_game_events_callbacks.common_full_cover) then
        printLog("callFullCoverCallback common_full_cover table is nil or empty")
        return
    end
    handleTableWithBoolParam(common_game_events_callbacks.common_full_cover, isFullCover)
end

local function callMapModeCallback(mapMode)
    --printLog("callMapModeCallback begin")
    if commonlib_isTableEmpty(common_game_events_callbacks.common_map_mode) then
        printLog("callMapModeCallback common_map_mode table is nil or empty")
        return
    end
    handleTableWithStringParam(common_game_events_callbacks.common_map_mode, mapMode)
end

local function callChatWindowCallback(isOpen)
    --printLog("callChatWindowCallback begin")
    if commonlib_isTableEmpty(common_game_events_callbacks.common_chat_window) then
        printLog("callChatWindowCallback common_chat_window table is nil or empty")
        return
    end
    handleTableWithBoolParam(common_game_events_callbacks.common_chat_window, isOpen)
end

local function callEquipmentCallback(equipment)
    --printLog("callEquipmentCallback begin")
    if commonlib_isTableEmpty(common_game_events_callbacks.common_equipment) then
        printLog("callEquipmentCallback common_equipment table is nil or empty")
        return
    end
    handleTableWithStringParam(common_game_events_callbacks.common_equipment, equipment)
end

local function callAttackModeCallback(attackMode)
    --printLog("callAttackModeCallback begin")
    if commonlib_isTableEmpty(common_game_events_callbacks.common_attck_mode) then
        printLog("callAttackModeCallback common_attck_mode table is nil or empty")
        return
    end
    handleTableWithStringParam(common_game_events_callbacks.common_attck_mode, attackMode)
end

local function reportFloatEntranceShowState(state)
    printLog("float_window===================" .. "埋点测试" .. tostring(state));
    local reportLib = Report();
    if reportLib ~= nil then
        printLog("float_window===================" .. "埋点测试");
        reportLib:report({
            ["table_name"] = GAMEMASTER_GAME_ASSISTANT_SRV,
            ["report_data"] = { ["show_float"] = state}
        })
    end
end

local function callGameEventsCallbacks()
    if not shouldCallGameEventsCallbacks() then
        printLog("callGameEventsCallbacks shouldCallGameEventsCallbacks return false")
        return
    end

    --printLog("callGameEventsCallbacks begin")
    if not isGameStartCalled then
        callGameStartCallback()
        isGameStartCalled = true
    end

    local currentFullCover = getState(KEY_IS_FULL_COVER)
    if currentFullCover ~= lastIsFullCover then
        printLog("callGameEventsCallbacks currentFullCover: " .. tostring(currentFullCover) .. tostring(" lastIsFullCover: ") .. tostring(lastIsFullCover))
        lastIsFullCover = currentFullCover
        callFullCoverCallback(lastIsFullCover)
        if lastIsFullCover then
            return
        end
    end

    local currentLargeMap = getState(KEY_LARGE_MAP)
    if currentLargeMap ~= lastLargeMap then
        printLog("callGameEventsCallbacks currentLargeMap: " .. tostring(currentLargeMap) .. tostring(" lastLargeMap: ") .. tostring(lastLargeMap))
        lastLargeMap = currentLargeMap
        callMapModeCallback(lastLargeMap)
    end

    local currentChatOpen = getState(KEY_IS_CHAT_WINDOW_OPEN)
    if currentChatOpen ~= lastIsChatOpen then
        printLog("callGameEventsCallbacks currentChatOpen: " .. tostring(currentChatOpen) .. tostring(" lastIsChatOpen: ") .. tostring(lastIsChatOpen))
        lastIsChatOpen = currentChatOpen
        callChatWindowCallback(lastIsChatOpen)
    end

    local currentEquipment = getState(KEY_SHOP_MENU_POSITION)
    if currentEquipment ~= lastEquipment then
        printLog("callGameEventsCallbacks currentEquipment: " .. tostring(currentEquipment) .. tostring(" lastEquipment: ") .. tostring(lastEquipment))
        lastEquipment = currentEquipment
        callEquipmentCallback(lastEquipment)
    end

    local currentAttackMode = getState(KEY_HERO_ATTACK_MODE)
    if currentAttackMode ~= lastAttackMode then
        printLog("callGameEventsCallbacks currentAttackMode: " .. tostring(currentAttackMode) .. tostring(" lastAttackMode: ") .. tostring(lastAttackMode))
        lastAttackMode = currentAttackMode
        callAttackModeCallback(lastAttackMode)
    end

    callGameRunningCallback()
end

local function clearCallbackTables()
    if common_life_circle_callbacks ~= nil then
        common_life_circle_callbacks = nil
    end

    if common_game_events_callbacks ~= nil then
        common_game_events_callbacks = nil
    end
end

--- 获取图片的相似度
local function getImageSimilarity(rectInfo)
    if rectInfo == nil then
        return 0
    end
    return commonlib_recognizeMatchResource(rectInfo.rect, rectInfo.path)
end

--- 进行图像识别，判断识别区域与参考图片是否相同
--- @param recognizeInfoTable 识别信息表，包含三个部分：rect、path 和 threshold
--- @return isSame 是否相同
local function doImageRecognize(recognizeInfoTable)
    local similarity = getImageSimilarity(recognizeInfoTable);
    printLog("path : " .. recognizeInfoTable.path .. ", similarity : " .. tostring(similarity) .. ", threshold : " .. recognizeInfoTable.threshold);
    return similarity > recognizeInfoTable.threshold;
end

local function debugState()
    local gameState = getState(KEY_GAME_STATE)
    local msg = ""
    if gameState == GAME_STATE_NOTSTART then
        msg = "游戏未开始状态"
    elseif gameState == GAME_STATE_LOADING then
        msg = "游戏加载状态"
    elseif gameState == GAME_STATE_RUNNING then
        msg = "游戏运行状态"
    elseif gameState == GAME_STATE_FINISH then
        msg = "游戏结束状态"
    end

    commonlib_runOnUIThread(function()
        -- 游戏状态
        if tvGameState ~= nil then
            tvGameState:setText("当前游戏状态：" .. msg);
        end

        -- 不可变元素
        if tvIsIn5v5Map ~= nil then
            tvIsIn5v5Map:setText("是否在5v5地图中：" .. tostring(getState(KEY_IS_IN_5V5_MAP)));
        end
        if tvHeroSkillCount ~= nil then
            tvHeroSkillCount:setText("英雄技能个数：" .. tostring(getState(KEY_HERO_SKILL_COUNT)));
        end
        if tvSummonerSkillCount ~= nil then
            tvSummonerSkillCount:setText("召唤师技能个数：" .. tostring(getState(KEY_SUMMONER_SKILL_COUNT)));
        end

        -- 可变元素
        if tvShopMenuPosition ~= nil then
            tvShopMenuPosition:setText("商店菜单位置：" .. tostring(getState(KEY_SHOP_MENU_POSITION)));
        end
        if tvHeroAttackMode ~= nil then
            tvHeroAttackMode:setText("英雄攻击模式：" .. tostring(getState(KEY_HERO_ATTACK_MODE)));
        end

        -- 遮挡
        --if tvIsInFullCover ~= nil then
        --    tvIsInFullCover:setText("是否全遮挡：" .. tostring(getState(KEY_IS_FULL_COVER)));
        --end
        --if tvIsChatWindowOpen ~= nil then
        --    tvIsChatWindowOpen:setText("聊天窗口是否打开：" .. tostring(getState(KEY_IS_CHAT_WINDOW_OPEN)));
        --end
        --if tvLargeMapState ~= nil then
        --    tvLargeMapState:setText("大地图状态：" .. tostring(getState(KEY_LARGE_MAP)));
        --end
    end)
end

local function doImageRecognizeByInfos(infos)
    for index, info in pairs(infos) do
        if doImageRecognize(info) then
            return true;
        end
    end
    return false;
end

local function getShopMenuPosition()
    local shopMenuPosition
    local lastShopMenuPos = getState(KEY_SHOP_MENU_POSITION);

    -- 通过上次的商店菜单位置来判断商店菜单是否存在，可用于减少判断次数
    if lastShopMenuPos == SHOP_MENU_POSITION_LEFT then
        if doImageRecognize(SHOP_MENU_POSITION_RECOGNIZE_TABLE[SHOP_MENU_POSITION_LEFT]) then
            shopMenuPosition = SHOP_MENU_POSITION_LEFT;
        elseif doImageRecognize(SHOP_MENU_POSITION_RECOGNIZE_TABLE[SHOP_MENU_POSITION_RIGHT]) then
            shopMenuPosition = SHOP_MENU_POSITION_RIGHT;
        end
    else
        if doImageRecognize(SHOP_MENU_POSITION_RECOGNIZE_TABLE[SHOP_MENU_POSITION_RIGHT]) then
            shopMenuPosition = SHOP_MENU_POSITION_RIGHT;
        elseif doImageRecognize(SHOP_MENU_POSITION_RECOGNIZE_TABLE[SHOP_MENU_POSITION_LEFT]) then
            shopMenuPosition = SHOP_MENU_POSITION_LEFT;
        end
    end

    return shopMenuPosition;
end

------------ 游戏是否运行状态相关函数----------------
local function isInGameLoading()
    printLog("=====判断是否在游戏加载状态");
    return doImageRecognizeByInfos(GAME_STATE_RECOGNIZE_TABLE[GAME_STATE_LOADING]);
end

local function isInGameRunning()
    printLog("=====判断是否在游戏运行状态");
    local shopMenuPosition = getShopMenuPosition();
    if shopMenuPosition == nil then
        -- 若没有获取到出装菜单，则判断商店菜单在左侧时设置按钮是否存在
        return doImageRecognize(HAS_SETTING_BUTTON_RECOGNZIE_TABLE[1]);
    else
        setState(KEY_SHOP_MENU_POSITION, shopMenuPosition);
        return true;
    end
end

local function isInGameFinish()
    printLog("=====判断是否在游戏结束状态");
    return doImageRecognizeByInfos(GAME_STATE_RECOGNIZE_TABLE[GAME_STATE_FINISH]);
end

--- 根据上一次的游戏状态获取当前的游戏状态
local function getCurrentState(lastState)
    local currentState;
    if lastState == GAME_STATE_NOTSTART then
        if isInGameLoading() then
            printLog("由游戏未开始状态进入游戏加载状态");
            currentState = GAME_STATE_LOADING;
        elseif isInGameRunning() then
            printLog("由游戏未开始状态进入了游戏运行状态");
            currentState = GAME_STATE_RUNNING;
        end
    elseif lastState == GAME_STATE_LOADING then
        --  如果还是处于游戏加载状态，则不做任何处理（可减少识别次数）
        if isInGameLoading() then
            currentState = GAME_STATE_LOADING;
        elseif isInGameRunning() then
            printLog("由游戏加载状态进入了游戏运行状态");
            currentState = GAME_STATE_RUNNING;
        end
    elseif lastState == GAME_STATE_RUNNING then
        --  如果还在游戏运行状态，则不做任何处理（可减少识别次数）
        if isInGameRunning() then
            currentState = GAME_STATE_RUNNING;
        elseif isInGameFinish() then
            printLog("由游戏运行状态进入了游戏结束状态");
            currentState = GAME_STATE_FINISH;
        elseif isInGameLoading() then
            printLog("由游戏运行状态进入了游戏加载状态，可能情况：用户切出界面后导致掉线，需要重连");
            currentState = GAME_STATE_LOADING;
        end
    end
    return currentState;
end

--- 设置是否有暂停按钮
local function setHasPauseButton()
    local hasPauseButton = false;
    for k, recognizeInfo in pairs(HAS_PAUSE_BUTTON_RECOGNIZE_TABLE) do
        hasPauseButton = doImageRecognize(recognizeInfo);
        if hasPauseButton then
            break;
        end
    end
    setState(KEY_HAS_PAUSE_BUTTON, hasPauseButton);
end

--- 设置是否有设置按钮
local function setHasSettingButton()
    local hasSettingButton = false;
    for k, recognizeInfo in pairs(HAS_SETTING_BUTTON_RECOGNZIE_TABLE) do
        hasSettingButton = doImageRecognize(recognizeInfo);
        if hasSettingButton then
            break;
        end
    end
    setState(KEY_HAS_SETTING_BUTTON, hasSettingButton);
end

--- 设置英雄技能个数
local function setHeroSkillCount()
    local heroSkillCount = HERO_SKILL_COUNT_THREE;
    -- 四技能英雄
    for k, recognizeInfo in pairs(FOUR_SKILL_HERO_RECOGNIZE_TABLE) do
        if doImageRecognize(recognizeInfo) then
            heroSkillCount = HERO_SKILL_COUNT_FOUR;
            break;
        end
    end
    setState(KEY_HERO_SKILL_COUNT, heroSkillCount);
end

--- 设置召唤师技能个数
local function setSummonerSkillCount()
    if not doImageRecognize(SUMMONER_SKILL_COUNT_RECOGNIZE_TABLE.THIRD_SKILL_POSITION) then
        setState(KEY_SUMMONER_SKILL_COUNT, SUMMONER_SKILL_COUNT_TWO);
    elseif doImageRecognize(SUMMONER_SKILL_COUNT_RECOGNIZE_TABLE.FORTH_SKILL_POSITION) then
        setState(KEY_SUMMONER_SKILL_COUNT, SUMMONER_SKILL_COUNT_FOUR);
    else
        setState(KEY_SUMMONER_SKILL_COUNT, SUMMONER_SKILL_COUNT_THREE)
    end
end

local function setHeroAttackMode()
    if doImageRecognize(HERO_ATTACK_MODE_RECOGNIZE_TALBE[HERO_ATTACK_MODE_ADVANCED_FREE]) then
        setState(KEY_HERO_ATTACK_MODE, HERO_ATTACK_MODE_ADVANCED_FREE);
    elseif doImageRecognize(HERO_ATTACK_MODE_RECOGNIZE_TALBE[HERO_ATTACK_MODE_LOCK]) then
        setState(KEY_HERO_ATTACK_MODE, HERO_ATTACK_MODE_LOCK);
    else
        setState(KEY_HERO_ATTACK_MODE, HERO_ATTACK_MODE_FREE);
    end
end

--- 设置是否在5v5地图中
local function setIsIn5v5Map()
    if doImageRecognize(S9_5V5_MAP_1_RECOGNIZE_INFO) or doImageRecognize(S9_5V5_MAP_2_RECOGNIZE_INFO) then
        setState(KEY_IS_IN_5V5_MAP, true);
    end
end

--- 刚刚进入游戏的时候做一些操作
local function doWhenEnterGame()
    enterGameTime = commonlib_getCurrentTime();

    -- 初次进入游戏，5v5地图识别元素会延迟出现，英雄攻击模式会有一段变暗的时间
    -- 这两个元素的识别需要加上重试次数，其它的一次识别即可

    -- 识别英雄技能个数
    setHeroSkillCount();
    -- 识别召唤师技能个数
    setSummonerSkillCount();
    -- 识别是否存在暂停按钮
    setHasPauseButton();
end

--- 进行重试识别，该元素包括5v5地图和英雄攻击模式
local function doRetryRecognize()
    local timeInterval = commonlib_getCurrentTime() - enterGameTime;
    if timeInterval <= RETRY_RECOGNIZE_DURATION then
        if not getState(KEY_IS_IN_5V5_MAP) then
            setIsIn5v5Map();
        end

        if getState(KEY_HERO_ATTACK_MODE) == HERO_ATTACK_MODE_FREE then
            setHeroAttackMode();
        end

        if not getState(KEY_HAS_SETTING_BUTTON) then
            setHasSettingButton();
        end
    end
end

local function setChatWindowState()
    setState(KEY_IS_CHAT_WINDOW_OPEN, doImageRecognize(CHAT_WINDOW_RECOGNIZE_INFO));
end

--- 设置小地图的状态
local function setLargeMapState()
    local lastState = getState(KEY_LARGE_MAP);
    -- 小地图上一刻为隐藏，则需要判断当前的所有状态
    if lastState == LARGE_MAP_HIDE then
        if doImageRecognize(SMALL_MAP_RECOGNIZE_TABLE[LARGE_MAP_HIDE]) then
            setState(KEY_LARGE_MAP, LARGE_MAP_HIDE);
        elseif doImageRecognize(SMALL_MAP_RECOGNIZE_TABLE[LARGE_MAP_LEFT_ZOOMOUT]) then
            setState(KEY_LARGE_MAP, LARGE_MAP_LEFT_ZOOMOUT);
        elseif doImageRecognize(SMALL_MAP_RECOGNIZE_TABLE[LARGE_MAP_RIGHT_ZOOMOUT]) then
            setState(KEY_LARGE_MAP, LARGE_MAP_RIGHT_ZOOMOUT);
        end
    else
        -- 小地图上一刻不为隐藏状态，则此刻需要判断它是否处于隐藏状态
        if doImageRecognize(SMALL_MAP_RECOGNIZE_TABLE[LARGE_MAP_HIDE]) then
            setState(KEY_LARGE_MAP, LARGE_MAP_HIDE);
        end
    end
end

--- 设置半遮挡状态，包括：聊天窗口是否打开、小地图是否打开
local function setPartCoverState()
    setChatWindowState();
    setLargeMapState();
end

local function isInputMethodWindowOpen()
    return doImageRecognize(INPUT_METHOD_RECOGNIZE_INFO);
end

------------- 界面元素相关------------------
--- 更新可变元素，包括：商店位置，英雄攻击模式
local function updateAlterableElement()
    if shouldUpdateAlterableElement then
        setHeroAttackMode();
        shouldUpdateAlterableElement = false;
    end
end

local function setIsJustEnterGame()
    local currentMap = getState(KEY_IS_IN_5V5_MAP);
    -- 当前处于5v5地图中，而上一次不是
    local justEnterGame = currentMap and not lastIsIn5v5Map;
    lastIsIn5v5Map = currentMap;
    setState(KEY_IS_JUST_ENTER_GAME, justEnterGame);
end

local function common_initVariable()
    printLog("common_initVariable begin: ");
    lastState = GAME_STATE_NOTSTART;
    shouldUpdateAlterableElement = true;
    lastIsIn5v5Map = false;

    globalGameConfig = GlobalGameConfig();

    local floatWindow = UnClickableFloatView();
    --    游戏状态
    tvGameState = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, -160, 0, 3);

    --  不可变元素
    tvIsIn5v5Map = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, -160, 50, 3);
    tvHeroSkillCount = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, -160, 90, 3);
    tvSummonerSkillCount = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, -160, 130, 3);

    --  可变元素
    tvShopMenuPosition = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, -160, 180, 3);
    tvHeroAttackMode = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, -160, 220, 3);

    --  遮挡
    tvIsInFullCover = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, -160, 270, 3);
    tvLargeMapState = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, -160, 310, 3);
    tvIsChatWindowOpen = floatWindow:addDebugTextView("", "#FFFF4081", "14sp", Anchor().TOP, -160, 350, 3);
end

local function initState()
    printLog("初始化状态值");

    -- 游戏状态
    setState(KEY_GAME_STATE, GAME_STATE_NOTSTART);

    setState(KEY_IS_JUST_ENTER_GAME, false);

    -- 不变元素状态
    setState(KEY_IS_IN_5V5_MAP, false);
    setState(KEY_HERO_SKILL_COUNT, HERO_SKILL_COUNT_THREE);
    setState(KEY_SUMMONER_SKILL_COUNT, SUMMONER_SKILL_COUNT_THREE);
    setState(KEY_HAS_PAUSE_BUTTON, false);
    setState(KEY_HAS_SETTING_BUTTON, false);

    -- 可变元素状态
    setState(KEY_SHOP_MENU_POSITION, SHOP_MENU_POSITION_LEFT);
    setState(KEY_HERO_ATTACK_MODE, HERO_ATTACK_MODE_FREE);

    -- 遮挡状态
    setState(KEY_IS_FULL_COVER, false);
    setState(KEY_LARGE_MAP, LARGE_MAP_HIDE);
    setState(KEY_IS_CHAT_WINDOW_OPEN, false);

    isGameStartCalled = false
    lastIsFullCover = nil
    lastIsChatOpen = nil
    lastLargeMap = nil
    lastEquipment = nil
    lastAttackMode = nil
end

local function addReferImage()
    printLog(" addReferImage begin ")
    -- 游戏状态
    for gameStateValue, recognizeInfos in pairs(GAME_STATE_RECOGNIZE_TABLE) do
        for index, recognizeInfo in pairs(recognizeInfos) do
            commonlib_recognizeAddImage(recognizeInfo.path);
        end
    end

    -- 不变元素
    -- 是否5v5地图
    --commonlib_recognizeAddImage(IS_IN_5V5_MAP_RECOGNIZE_INFO.path);
    commonlib_recognizeAddImage(S9_5V5_MAP_1_RECOGNIZE_INFO.path);
    commonlib_recognizeAddImage(S9_5V5_MAP_2_RECOGNIZE_INFO.path);

    -- 是否有设置按钮
    for k, recognizeInfo in pairs(HAS_SETTING_BUTTON_RECOGNZIE_TABLE) do
        commonlib_recognizeAddImage(recognizeInfo.path);
        break;
    end
    -- 是否有暂停按钮
    for k, recognizeInfo in pairs(HAS_PAUSE_BUTTON_RECOGNIZE_TABLE) do
        commonlib_recognizeAddImage(recognizeInfo.path);
        break;
    end
    -- 四技能英雄
    for k, recognizeInfo in pairs(FOUR_SKILL_HERO_RECOGNIZE_TABLE) do
        commonlib_recognizeAddImage(recognizeInfo.path);
    end
    -- 召唤师技能
    for k, recognizeInfo in pairs(SUMMONER_SKILL_COUNT_RECOGNIZE_TABLE) do
        commonlib_recognizeAddImage(recognizeInfo.path);
        break;
    end

    -- 可变元素
    -- 商店菜单
    for k, recognizeInfo in pairs(SHOP_MENU_POSITION_RECOGNIZE_TABLE) do
        commonlib_recognizeAddImage(recognizeInfo.path);
    end
    -- 英雄攻击模式
    for k, recognizeInfo in pairs(HERO_ATTACK_MODE_RECOGNIZE_TALBE) do
        commonlib_recognizeAddImage(recognizeInfo.path);
    end

    -- 半遮挡
    -- 聊天窗口
    commonlib_recognizeAddImage(CHAT_WINDOW_RECOGNIZE_INFO.path);
    -- 小地图状态
    commonlib_recognizeAddImage(SMALL_MAP_RECOGNIZE_TABLE[LARGE_MAP_HIDE].path);
    commonlib_recognizeAddImage(SMALL_MAP_RECOGNIZE_TABLE[LARGE_MAP_LEFT_ZOOMOUT].path);

    -- 其它
    -- 设置窗口
    commonlib_recognizeAddImage(SETTING_WINDOW_RECOGNIZE_INFO.path);
    -- 输入法
    commonlib_recognizeAddImage(INPUT_METHOD_RECOGNIZE_INFO.path);
end

local function unInitVariable()
    lastState = nil
    shouldUpdateAlterableElement = nil
    globalGameConfig = nil
end

local function resetGame()
    initState();

    lastState = GAME_STATE_NOTSTART;
    shouldUpdateAlterableElement = true;
    lastIsIn5v5Map = false;

    debugState();
    hasReportLoadingData = false;
    hasReportFloatWindowData = false;
end

function setXOffsetInRecognizeInfo(recognizeInfo)
    recognizeInfo.rect.left = recognizeInfo.rect.left + X_OFFSET_IN_18TO9_SCREEN;
end

local function setXOffSet()
    --- 在18:9 的手机上，对几个区域的坐标要进行偏移
    printLog("");
    --- 召唤师技能识别
    setXOffsetInRecognizeInfo(SUMMONER_SKILL_COUNT_RECOGNIZE_TABLE.THIRD_SKILL_POSITION);
    setXOffsetInRecognizeInfo(SUMMONER_SKILL_COUNT_RECOGNIZE_TABLE.FORTH_SKILL_POSITION);

    ---  英雄攻击模式
    setXOffsetInRecognizeInfo(HERO_ATTACK_MODE_RECOGNIZE_TALBE[HERO_ATTACK_MODE_ADVANCED_FREE]);
    setXOffsetInRecognizeInfo(HERO_ATTACK_MODE_RECOGNIZE_TALBE[HERO_ATTACK_MODE_LOCK]);
end

local function init()
    printLog("common init ：init");
    common_initVariable();
    initState();
    addReferImage();
    callLifeCircleInit()

    if commonlib_isScreenRatio18To9() then
        printLog("手机比例为18:9， 需要对某些区域的x进行偏移");
        setXOffSet();
    end
end

local function uninit()
    printLog("local uninit");
    unInitVariable();
    callLifeCircleUninit()
    clearCallbackTables()
end

local function work()
    printLog("local common_state ------------------------");

    if lastState == GAME_STATE_FINISH then
        callGameOverCallback()
        resetGame();
        return;
    elseif lastState == GAME_STATE_LOADING then
        callGameLoadingCallback()
    end

    -- 获取当前游戏状态
    local currentState = getCurrentState(lastState);

    -- 进入游戏时刻，需要确定一些界面元素的状态
    if (currentState == GAME_STATE_RUNNING) and (lastState ~= GAME_STATE_RUNNING) then
        doWhenEnterGame();
    end

    -- 上一次游戏状态为运行状态，而当前未获取到游戏状态(即不是其他状态，也不是游戏运状态)
    -- 则认为是判断游戏运行状态的元素被遮挡住了
    local isRecognizeGameRunningElementCovered = (lastState == GAME_STATE_RUNNING and currentState == nil);
    if isRecognizeGameRunningElementCovered then
        currentState = GAME_STATE_RUNNING;
    end

    -- 当前状态是游戏状态，则需要确定某些状态
    if currentState == GAME_STATE_RUNNING then
        setPartCoverState(); -- 设置半遮挡状态，游戏运行时的每一帧都识别
        local isInFullCover = isInputMethodWindowOpen();
        if isRecognizeGameRunningElementCovered then
            --printLog("判断游戏运行状态的元素被遮挡，需要判断是小地图展开遮挡还是全遮挡");
            isInFullCover = isInFullCover or getState(KEY_LARGE_MAP) == LARGE_MAP_HIDE;
            printLog("当前是否处于全遮挡状态：" .. tostring(isInFullCover));
            if isInFullCover and doImageRecognize(SETTING_WINDOW_RECOGNIZE_INFO) then
                printLog("设置页面被打开，则说明界面可变元素需要更新");
                shouldUpdateAlterableElement = true;
            end
        else
            updateAlterableElement(); -- 更新界面可变元素

            -- 初次进入游戏，5v5地图识别元素会延迟出现，英雄攻击模式会有一段变暗的时间
            -- 这两个元素的识别需要加上重试次数
            doRetryRecognize();
        end
        setState(KEY_IS_FULL_COVER, isInFullCover);
    end

    if currentState ~= nil then
        lastState = currentState;
    end

    setIsJustEnterGame();
    setState(KEY_GAME_STATE, lastState);
    debugState();
    callGameEventsCallbacks()

    if isJustEnterGame() then
--        reportMoneyAreaAndAttackPattern()
        callJustEnterGameCallback()
    end

    if currentState == GAME_STATE_LOADING and not hasReportLoadingData then
        reportFloatEntranceShowState(REPORT_SHOW_LOADING_VIEW)
        hasReportLoadingData = true;
    end
    local shouldReport = (commonlib_getGameParam(KEY_GAME_STATE) == GAME_STATE_RUNNING);
    shouldReport = shouldReport and (not commonlib_getGameParam(KEY_IS_IN_5V5_MAP));
    shouldReport = shouldReport and not hasReportFloatWindowData;
    if shouldReport then
        reportFloatEntranceShowState(REPORT_SHOW_NOT_FLOAT_WINDOW_VIEW);
        hasReportFloatWindowData = true;
    end
end

table.insert(core_scripts, { init, uninit, work })

