--- 界面美化脚本

-- 界面元素资源表
local themes = {
    ["gold"] = {
        ["widget"] = {
            ["0"] = { "widget_0.png", "TOPLEFT", 0, 0, 347, 347 },
            ["3"] = { "widget_3.png", "TOPLEFT", 352, 146, 60, 61 },
            ["4"] = { "widget_4.png", "TOPLEFT", 352, 214, 60, 61 },
            ["5"] = { "widget_5.png", "TOPLEFT", 345, 281, 73, 73 },
            ["8"] = { "widget_8.png", "LEFT", -1, -158, 140, 167 },
            ["9"] = { "widget_9.png", "TOPRIGHT", -140, 0, 140, 105 },
            ["10"] = { "widget_10.png", "BOTTOMLEFT", 0, -308, 308, 308 },
            ["11"] = { "widget_11.png", "BOTTOMRIGHT", -1153, -176, 126, 126 },
            ["12"] = { "widget_12.png", "BOTTOMRIGHT", -1009, -176, 126, 126 },
            ["13"] = { "widget_13.png", "BOTTOMRIGHT", -868, -176, 126, 116 },
            ["14"] = { "widget_14.png", "BOTTOMRIGHT", -718, -176, 126, 126 },
            ["15"] = { "widget_15.png", "BOTTOMRIGHT", -583, -230, 192, 192 },
            ["16"] = { "widget_16.png", "BOTTOMRIGHT", -468, -430, 192, 192 },
            ["17"] = { "widget_17.png", "BOTTOMRIGHT", -267, -545, 192, 192 },
            ["18"] = { "widget_18.png", "BOTTOMRIGHT", -292, -280, 160, 172 },
            ["19"] = { "widget_19.png", "TOPRIGHT", -83, 359, 76, 76 },
            ["20"] = { "widget_20.png", "TOPRIGHT", -83, 274, 76, 76 },
            ["21"] = { "widget_21.png", "TOPLEFT", 98, 381, 76, 76 },
            ["22"] = { "widget_22.png", "TOPRIGHT", -83, 188, 76, 76 },
            ["23"] = { "widget_23.png", "TOPLEFT", 7, 381, 76, 76 },
            ["24"] = { "widget_24.png", "TOPRIGHT", -83, 101, 76, 76 },
            ["25"] = { "widget_25.png", "TOPLEFT", 189, 381, 76, 76 },
            ["30"] = { "widget_30.png", "TOPRIGHT", -681, 0, 681, 84 },
            ["32"] = { "widget_32.png", "TOPRIGHT", -612, 0, 470, 110 },
            ["33"] = { "widget_33.png", "TOPLEFT", 343, 1, 74, 70 },
            ["34"] = { "widget_34.png", "TOPLEFT", 409, 1, 74, 70 },
            ["35"] = { "widget_35.png", "TOPLEFT", 478, 1, 74, 70 },
            ["36"] = { "widget_36.png", "TOPLEFT", 545, 1, 74, 70 },
            ["42"] = { "widget_42.png", "BOTTOMRIGHT", -382, -152, 104, 102 },
            ["43"] = { "widget_43.png", "BOTTOMRIGHT", -133, -366, 104, 102 },
            ["45"] = { "widget_45.png", "BOTTOMRIGHT", -1431, -246, 1431, 246 },
            ["46"] = { "widget_46.png", "BOTTOMRIGHT", -565, -214, 162, 162 },
            ["47"] = { "widget_47.png", "BOTTOMRIGHT", -525, -377, 162, 162 },
            ["48"] = { "widget_48.png", "BOTTOMRIGHT", -385, -502, 162, 162 },
            ["49"] = { "widget_49.png", "BOTTOMRIGHT", -212, -530, 162, 162 },
            ["50"] = { "widget_50.png", "BOTTOMRIGHT", -1430, -51, 1157, 51 },
            ["51"] = { "widget_51.png", "TOPRIGHT", -223, 101, 104, 104 },
            ["52"] = { "widget_52.png", "TOPLEFT", 288, 369, 104, 104 }
        },
        ["stat"] = {
            ["summonerSkillCount"] = {
                ["2"] = {
                    ["exclude"] = { "11", "12" }
                },
                ["3"] = {
                    ["exclude"] = { "11" }
                },
                ["4"] = {
                    ["exclude"] = nil
                }
            },
            ["heroSkillCount"] = {
                ["3"] = {
                    ["exclude"] = { "46", "47", "48", "49" }
                },
                ["4"] = {
                    ["exclude"] = { "15", "16", "17" }
                }
            },
            ["heroAttackMode"] = {
                ["FREE"] = {
                    ["exclude"] = { "42", "43", "50" }
                },
                ["ADVANCED_FREE"] = {
                    ["exclude"] = { "50" }
                },
                ["LOCK"] = {
                    ["exclude"] = { "42", "43", "45" }
                }
            },
            ["shop"] = {
                ["LEFT"] = {
                    ["exclude"] = { "9", "21", "23", "25", "32", "52" }
                },
                ["RIGHT"] = {
                    ["exclude"] = { "8", "20", "22", "24", "30", "51" }
                }
            },
            ["float_window"] = {
                ["RIGHT_WINDOW"] = {
                    ["exclude"] = { "52" },
                    ["include"] = { "51" }
                },
                ["LEFT_WINDOW"] = {
                    ["exclude"] = { "51" },
                    ["include"] = { "52" }
                }
            },
            ["largeMap"] = {
                ["HIDE"] = {
                    ["exclude"] = nil
                },
                ["LEFT"] = {
                    ["exclude"] = { "0", "3", "4", "5", "8", "10", "21", "23", "25", "33", "34", "35", "36", "52" },
                    ["restore"] = {
                        ["leftEquipment"] = { "0", "3", "4", "5", "8", "10", "33", "34", "35", "36" },
                        ["rightEquipment"] = { "0", "3", "4", "5", "10", "21", "23", "25", "33", "34", "35", "36", "52" }
                    }
                },
                ["RIGHT"] = {
                    ["exclude"] = { "5", "9", "16", "17", "18", "19", "20", "22", "24", "30", "32", "43", "47", "48", "49", "51" },
                    ["restore"] = {
                        ["leftEquipment"] = { "5", "16", "17", "18", "19", "20", "22", "24", "30", "43", "47", "48", "49", "51" },
                        ["rightEquipment"] = { "5", "9", "16", "17", "18", "19", "32", "43", "47", "48", "49" }
                    }
                }
            },
            ["chat"] = {
                ["exclude"] = { "9", "16", "17", "20", "22", "24", "30", "32", "43", "48", "49", "51" },
                ["restore"] = {
                    ["leftEquipment"] = { "16", "17", "20", "22", "24", "30", "43", "48", "49", "51" },
                    ["rightEquipment"] = { "9", "16", "17", "32", "43", "48", "49" }
                }
            }
        }
    },
    ["pink"] = {
        ["widget"] = {
            ["0"] = { "widget_0.png", "TOPLEFT", 0, 0, 346, 345 },
            ["3"] = { "widget_3.png", "TOPLEFT", 352, 145, 62, 62 },
            ["4"] = { "widget_4.png", "TOPLEFT", 352, 213, 62, 62 },
            ["5"] = { "widget_5.png", "TOPLEFT", 345, 281, 75, 75 },
            ["8"] = { "widget_8.png", "LEFT", 1, -154, 140, 167 },
            ["9"] = { "widget_9.png", "TOPRIGHT", -139, 0, 140, 105 },
            ["10"] = { "widget_10.png", "BOTTOMLEFT", 0, -308, 308, 308 },
            ["11"] = { "widget_11.png", "BOTTOMRIGHT", -1160, -181, 138, 138 },
            ["12"] = { "widget_12.png", "BOTTOMRIGHT", -1016, -181, 138, 138 },
            ["13"] = { "widget_13.png", "BOTTOMRIGHT", -873, -181, 138, 138 },
            ["14"] = { "widget_14.png", "BOTTOMRIGHT", -724, -181, 138, 138 },
            ["15"] = { "widget_15.png", "BOTTOMRIGHT", -575, -217, 174, 174 },
            ["16"] = { "widget_16.png", "BOTTOMRIGHT", -458, -418, 174, 174 },
            ["17"] = { "widget_17.png", "BOTTOMRIGHT", -257, -533, 174, 174 },
            ["18"] = { "widget_18.png", "BOTTOMRIGHT", -299, -286, 180, 184 },
            ["19"] = { "widget_19.png", "TOPRIGHT", -82, 360, 75, 75 },
            ["20"] = { "widget_20.png", "TOPRIGHT", -82, 276, 75, 75 },
            ["21"] = { "widget_21.png", "TOPLEFT", 99, 383, 75, 75 },
            ["22"] = { "widget_22.png", "TOPRIGHT", -82, 189, 75, 75 },
            ["23"] = { "widget_23.png", "TOPLEFT", 9, 383, 75, 75 },
            ["24"] = { "widget_24.png", "TOPRIGHT", -82, 103, 75, 75 },
            ["25"] = { "widget_25.png", "TOPLEFT", 193, 383, 75, 75 },
            ["30"] = { "widget_30.png", "TOPRIGHT", -664, 0, 664, 90 },
            ["32"] = { "widget_32.png", "TOPRIGHT", -612, 0, 470, 110 },
            ["33"] = { "widget_33.png", "TOPLEFT", 346, 0, 69, 72 },
            ["34"] = { "widget_34.png", "TOPLEFT", 413, 0, 69, 72 },
            ["35"] = { "widget_35.png", "TOPLEFT", 480, 0, 69, 72 },
            ["36"] = { "widget_36.png", "TOPLEFT", 548, 0, 69, 72 },
            ["42"] = { "widget_42.png", "BOTTOMRIGHT", -379, -153, 102, 89 },
            ["43"] = { "widget_43.png", "BOTTOMRIGHT", -131, -367, 102, 89 },
            ["45"] = { "widget_45.png", "BOTTOMRIGHT", -248, -244, 248, 244 },
            ["46"] = { "widget_46.png", "BOTTOMRIGHT", -552, -203, 140, 140 },
            ["47"] = { "widget_47.png", "BOTTOMRIGHT", -514, -368, 140, 140 },
            ["48"] = { "widget_48.png", "BOTTOMRIGHT", -375, -492, 140, 140 },
            ["49"] = { "widget_49.png", "BOTTOMRIGHT", -200, -520, 140, 140 },
            ["50"] = { "widget_50.png", "BOTTOMRIGHT", -1431, -72, 1138, 73 },
            ["51"] = { "widget_51.png", "TOPRIGHT", -223, 101, 104, 104 },
            ["52"] = { "widget_52.png", "TOPLEFT", 288, 369, 104, 104 }
        },
        ["stat"] = {
            ["summonerSkillCount"] = {
                ["2"] = {
                    ["exclude"] = { "11", "12" }
                },
                ["3"] = {
                    ["exclude"] = { "11" }
                },
                ["4"] = {
                    ["exclude"] = nil
                }
            },
            ["heroSkillCount"] = {
                ["3"] = {
                    ["exclude"] = { "46", "47", "48", "49" }
                },
                ["4"] = {
                    ["exclude"] = { "15", "16", "17" }
                }
            },
            ["heroAttackMode"] = {
                ["FREE"] = {
                    ["exclude"] = { "42", "43" }
                },
                ["ADVANCED_FREE"] = {
                    ["exclude"] = nil
                },
                ["LOCK"] = {
                    ["exclude"] = { "42", "43", "45" }
                }
            },
            ["shop"] = {
                ["LEFT"] = {
                    ["exclude"] = { "9", "21", "23", "25", "32", "52" }
                },
                ["RIGHT"] = {
                    ["exclude"] = { "8", "20", "22", "24", "30", "51" }
                }
            },
            ["float_window"] = {
                ["RIGHT_WINDOW"] = {
                    ["exclude"] = { "52" },
                    ["include"] = { "51" }
                },
                ["LEFT_WINDOW"] = {
                    ["exclude"] = { "51" },
                    ["include"] = { "52" }
                }
            },
            ["largeMap"] = {
                ["HIDE"] = {
                    ["exclude"] = nil
                },
                ["LEFT"] = {
                    ["exclude"] = { "0", "3", "4", "5", "8", "10", "21", "23", "25", "33", "34", "35", "36", "52" },
                    ["restore"] = {
                        ["leftEquipment"] = { "0", "3", "4", "5", "8", "10", "33", "34", "35", "36" },
                        ["rightEquipment"] = { "0", "3", "4", "5", "10", "21", "23", "25", "33", "34", "35", "36", "52" }
                    }
                },
                ["RIGHT"] = {
                    ["exclude"] = { "5", "9", "16", "17", "18", "19", "20", "22", "24", "30", "32", "43", "47", "48", "49", "51" },
                    ["restore"] = {
                        ["leftEquipment"] = { "5", "16", "17", "18", "19", "20", "22", "24", "30", "43", "47", "48", "49", "51" },
                        ["rightEquipment"] = { "5", "9", "16", "17", "18", "19", "32", "43", "47", "48", "49" }
                    }
                }
            },
            ["chat"] = {
                ["exclude"] = { "9", "16", "17", "20", "22", "24", "30", "32", "43", "48", "49", "51" },
                ["restore"] = {
                    ["leftEquipment"] = { "16", "17", "20", "22", "24", "30", "43", "48", "49", "51" },
                    ["rightEquipment"] = { "9", "16", "17", "32", "43", "48", "49" }
                }
            }
        }
    },
    ["blue"] = {
        ["widget"] = {
            ["0"] = { "widget_0.png", "TOPLEFT", 0, 0, 342, 342 },
            ["3"] = { "widget_3.png", "TOPLEFT", 352, 145, 60, 61 },
            ["4"] = { "widget_4.png", "TOPLEFT", 352, 213, 60, 61 },
            ["5"] = { "widget_5.png", "TOPLEFT", 345, 281, 73, 73 },
            ["8"] = { "widget_8.png", "LEFT", 2, -154, 139, 164 },
            ["9"] = { "widget_9.png", "TOPRIGHT", -137, 0, 139, 103 },
            ["10"] = { "widget_10.png", "BOTTOMLEFT", 0, -328, 323, 338 },
            ["11"] = { "widget_11.png", "BOTTOMRIGHT", -1158, -178, 132, 118 },
            ["12"] = { "widget_12.png", "BOTTOMRIGHT", -1014, -178, 132, 118 },
            ["13"] = { "widget_13.png", "BOTTOMRIGHT", -871, -178, 132, 118 },
            ["14"] = { "widget_14.png", "BOTTOMRIGHT", -722, -178, 132, 118 },
            ["15"] = { "widget_15.png", "BOTTOMRIGHT", -573, -224, 170, 181 },
            ["16"] = { "widget_16.png", "BOTTOMRIGHT", -456, -426, 170, 181 },
            ["17"] = { "widget_17.png", "BOTTOMRIGHT", -253, -540, 170, 181 },
            ["18"] = { "widget_18.png", "BOTTOMRIGHT", -297, -281, 163, 166 },
            ["19"] = { "widget_19.png", "TOPRIGHT", -81, 360, 73, 73 },
            ["20"] = { "widget_20.png", "TOPRIGHT", -81, 274, 73, 73 },
            ["21"] = { "widget_21.png", "TOPLEFT", 103, 384, 73, 73 },
            ["22"] = { "widget_22.png", "TOPRIGHT", -81, 189, 73, 73 },
            ["23"] = { "widget_23.png", "TOPLEFT", 12, 384, 73, 73 },
            ["24"] = { "widget_24.png", "TOPRIGHT", -81, 103, 73, 73 },
            ["25"] = { "widget_25.png", "TOPLEFT", 194, 384, 73, 73 },
            ["30"] = { "widget_30.png", "TOPRIGHT", -652, 0, 652, 82 },
            ["32"] = { "widget_32.png", "TOPRIGHT", -608, 0, 468, 108 },
            ["33"] = { "widget_33.png", "TOPLEFT", 351, 10, 63, 58 },
            ["34"] = { "widget_34.png", "TOPLEFT", 418, 10, 63, 58 },
            ["35"] = { "widget_35.png", "TOPLEFT", 486, 10, 63, 58 },
            ["36"] = { "widget_36.png", "TOPLEFT", 553, 10, 63, 58 },
            ["42"] = { "widget_42.png", "BOTTOMRIGHT", -384, -155, 103, 93 },
            ["43"] = { "widget_43.png", "BOTTOMRIGHT", -133, -367, 103, 93 },
            ["45"] = { "widget_45.png", "BOTTOMRIGHT", -1365, -279, 1351, 280 },
            ["46"] = { "widget_46.png", "BOTTOMRIGHT", -555, -210, 146, 155 },
            ["47"] = { "widget_47.png", "BOTTOMRIGHT", -517, -375, 146, 155 },
            ["48"] = { "widget_48.png", "BOTTOMRIGHT", -379, -501, 146, 155 },
            ["49"] = { "widget_49.png", "BOTTOMRIGHT", -203, -528, 146, 155 },
            ["50"] = { "widget_50.png", "BOTTOMRIGHT", -1365, -53, 1112, 53 },
            ["51"] = { "widget_51.png", "TOPRIGHT", -223, 101, 104, 104 },
            ["52"] = { "widget_52.png", "TOPLEFT", 288, 369, 104, 104 }
        },
        ["stat"] = {
            ["summonerSkillCount"] = {
                ["2"] = {
                    ["exclude"] = { "11", "12" }
                },
                ["3"] = {
                    ["exclude"] = { "11" }
                },
                ["4"] = {
                    ["exclude"] = nil
                }
            },
            ["heroSkillCount"] = {
                ["3"] = {
                    ["exclude"] = { "46", "47", "48", "49" }
                },
                ["4"] = {
                    ["exclude"] = { "15", "16", "17" }
                }
            },
            ["heroAttackMode"] = {
                ["FREE"] = {
                    ["exclude"] = { "42", "43", "50" }
                },
                ["ADVANCED_FREE"] = {
                    ["exclude"] = { "50" }
                },
                ["LOCK"] = {
                    ["exclude"] = { "42", "43", "45" }
                }
            },
            ["shop"] = {
                ["LEFT"] = {
                    ["exclude"] = { "9", "21", "23", "25", "32", "52" }
                },
                ["RIGHT"] = {
                    ["exclude"] = { "8", "20", "22", "24", "30", "51" }
                }
            },
            ["float_window"] = {
                ["RIGHT_WINDOW"] = {
                    ["exclude"] = { "52" },
                    ["include"] = { "51" }
                },
                ["LEFT_WINDOW"] = {
                    ["exclude"] = { "51" },
                    ["include"] = { "52" }
                }
            },
            ["largeMap"] = {
                ["HIDE"] = {
                    ["exclude"] = nil
                },
                ["LEFT"] = {
                    ["exclude"] = { "0", "3", "4", "5", "8", "10", "21", "23", "25", "33", "34", "35", "36", "52" },
                    ["restore"] = {
                        ["leftEquipment"] = { "0", "3", "4", "5", "8", "10", "33", "34", "35", "36" },
                        ["rightEquipment"] = { "0", "3", "4", "5", "10", "21", "23", "25", "33", "34", "35", "36", "52" }
                    }
                },
                ["RIGHT"] = {
                    ["exclude"] = { "5", "9", "16", "17", "18", "19", "20", "22", "24", "30", "32", "43", "47", "48", "49", "51" },
                    ["restore"] = {
                        ["leftEquipment"] = { "5", "16", "17", "18", "19", "20", "22", "24", "30", "43", "47", "48", "49", "51" },
                        ["rightEquipment"] = { "5", "9", "16", "17", "18", "19", "32", "43", "47", "48", "49" }
                    }
                }
            },
            ["chat"] = {
                ["exclude"] = { "9", "16", "17", "20", "22", "24", "30", "32", "43", "48", "49", "51" },
                ["restore"] = {
                    ["leftEquipment"] = { "16", "17", "20", "22", "24", "30", "43", "48", "49", "51" },
                    ["rightEquipment"] = { "9", "16", "17", "32", "43", "48", "49" }
                }
            }
        }
    },
    ["silver"] = {
        ["widget"] = {
            ["0"] = { "widget_0.png", "TOPLEFT", 0, 0, 342, 342 },
            ["3"] = { "widget_3.png", "TOPLEFT", 352, 144, 62, 62 },
            ["4"] = { "widget_4.png", "TOPLEFT", 352, 213, 62, 62 },
            ["5"] = { "widget_5.png", "TOPLEFT", 347, 281, 70, 70 },
            ["8"] = { "widget_8.png", "LEFT", 0, -154, 140, 164 },
            ["9"] = { "widget_9.png", "TOPRIGHT", -140, 0, 140, 106 },
            ["10"] = { "widget_10.png", "BOTTOMLEFT", 0, -312, 311, 312 },
            ["11"] = { "widget_11.png", "BOTTOMRIGHT", -1153, -188, 124, 131 },
            ["12"] = { "widget_12.png", "BOTTOMRIGHT", -1010, -188, 124, 131 },
            ["13"] = { "widget_13.png", "BOTTOMRIGHT", -867, -188, 124, 131 },
            ["14"] = { "widget_14.png", "BOTTOMRIGHT", -717, -188, 124, 131 },
            ["15"] = { "widget_15.png", "BOTTOMRIGHT", -574, -244, 177, 203 },
            ["16"] = { "widget_16.png", "BOTTOMRIGHT", -458, -446, 177, 203 },
            ["17"] = { "widget_17.png", "BOTTOMRIGHT", -258, -563, 177, 203 },
            ["18"] = { "widget_18.png", "BOTTOMRIGHT", -292, -282, 159, 160 },
            ["19"] = { "widget_19.png", "TOPRIGHT", -83, 359, 76, 76 },
            ["20"] = { "widget_20.png", "TOPRIGHT", -83, 273, 76, 76 },
            ["21"] = { "widget_21.png", "TOPLEFT", 98, 382, 76, 76 },
            ["22"] = { "widget_22.png", "TOPRIGHT", -83, 188, 76, 76 },
            ["23"] = { "widget_23.png", "TOPLEFT", 7, 382, 76, 76 },
            ["24"] = { "widget_24.png", "TOPRIGHT", -83, 101, 76, 76 },
            ["25"] = { "widget_25.png", "TOPLEFT", 189, 382, 76, 76 },
            ["30"] = { "widget_30.png", "TOPRIGHT", -662, 0, 662, 83 },
            ["32"] = { "widget_32.png", "TOPRIGHT", -610, 0, 468, 108 },
            ["33"] = { "widget_33.png", "TOPLEFT", 347, 5, 65, 63 },
            ["34"] = { "widget_34.png", "TOPLEFT", 415, 5, 65, 63 },
            ["35"] = { "widget_35.png", "TOPLEFT", 483, 5, 65, 63 },
            ["36"] = { "widget_36.png", "TOPLEFT", 550, 5, 65, 63 },
            ["42"] = { "widget_42.png", "BOTTOMRIGHT", -382, -155, 102, 99 },
            ["43"] = { "widget_43.png", "BOTTOMRIGHT", -132, -368, 102, 99 },
            ["45"] = { "widget_45.png", "BOTTOMRIGHT", -1430, -282, 1430, 292 },
            ["46"] = { "widget_46.png", "BOTTOMRIGHT", -558, -228, 149, 171 },
            ["47"] = { "widget_47.png", "BOTTOMRIGHT", -518, -392, 149, 171 },
            ["48"] = { "widget_48.png", "BOTTOMRIGHT", -379, -516, 149, 171 },
            ["49"] = { "widget_49.png", "BOTTOMRIGHT", -204, -545, 149, 171 },
            ["50"] = { "widget_50.png", "BOTTOMRIGHT", -1430, -57, 1156, 57 },
            ["51"] = { "widget_51.png", "TOPRIGHT", -223, 101, 104, 104 },
            ["52"] = { "widget_52.png", "TOPLEFT", 288, 369, 104, 104 }
        },
        ["stat"] = {
            ["summonerSkillCount"] = {
                ["2"] = {
                    ["exclude"] = { "11", "12" }
                },
                ["3"] = {
                    ["exclude"] = { "11" }
                },
                ["4"] = {
                    ["exclude"] = nil
                }
            },
            ["heroSkillCount"] = {
                ["3"] = {
                    ["exclude"] = { "46", "47", "48", "49" }
                },
                ["4"] = {
                    ["exclude"] = { "15", "16", "17" }
                }
            },
            ["heroAttackMode"] = {
                ["FREE"] = {
                    ["exclude"] = { "42", "43", "50" }
                },
                ["ADVANCED_FREE"] = {
                    ["exclude"] = { "50" }
                },
                ["LOCK"] = {
                    ["exclude"] = { "42", "43", "45" }
                }
            },
            ["shop"] = {
                ["LEFT"] = {
                    ["exclude"] = { "9", "21", "23", "25", "32", "52" }
                },
                ["RIGHT"] = {
                    ["exclude"] = { "8", "20", "22", "24", "30", "51" }
                }
            },
            ["float_window"] = {
                ["RIGHT_WINDOW"] = {
                    ["exclude"] = { "52" },
                    ["include"] = { "51" }
                },
                ["LEFT_WINDOW"] = {
                    ["exclude"] = { "51" },
                    ["include"] = { "52" }
                }
            },
            ["largeMap"] = {
                ["HIDE"] = {
                    ["exclude"] = nil
                },
                ["LEFT"] = {
                    ["exclude"] = { "0", "3", "4", "5", "8", "10", "21", "23", "25", "33", "34", "35", "36", "52" },
                    ["restore"] = {
                        ["leftEquipment"] = { "0", "3", "4", "5", "8", "10", "33", "34", "35", "36" },
                        ["rightEquipment"] = { "0", "3", "4", "5", "10", "21", "23", "25", "33", "34", "35", "36", "52" }
                    }
                },
                ["RIGHT"] = {
                    ["exclude"] = { "5", "9", "16", "17", "18", "19", "20", "22", "24", "30", "32", "43", "47", "48", "49", "51" },
                    ["restore"] = {
                        ["leftEquipment"] = { "5", "16", "17", "18", "19", "20", "22", "24", "30", "43", "47", "48", "49", "51" },
                        ["rightEquipment"] = { "5", "9", "16", "17", "18", "19", "32", "43", "47", "48", "49" }
                    }
                }
            },
            ["chat"] = {
                ["exclude"] = { "9", "16", "17", "20", "22", "24", "30", "32", "43", "48", "49", "51" },
                ["restore"] = {
                    ["leftEquipment"] = { "16", "17", "20", "22", "24", "30", "43", "48", "49", "51" },
                    ["rightEquipment"] = { "9", "16", "17", "32", "43", "48", "49" }
                }
            }
        }
    }
}

local SKIN_ORIENTATION_LANDSCAPE = 1 -- 1代表横屏
local SKIN_ORIENTATION_VERTICAL = 2 -- 2代表竖屏

local SKIN_BUTTON = "界面美化"
local SKIN_SWITCH_TEXT = "开启界面美化"
local SKIN_GOLD_TEXT = "黄金斗士"
local SKIN_PINK_TEXT = "甜心女王"
local SKIN_BLUE_TEXT = "炫蓝勇者"
local SKIN_SILVER_TEXT = "圣银骑士"

--- 界面美化类型
local SKIN_TYPE_GOLD = "gold"
local SKIN_TYPE_PINK = "pink"
local SKIN_TYPE_BLUE = "blue"
local SKIN_TYPE_SILVER = "silver"

local SKIN_GOLD_PATH_HEADER = "@assets:img/skin/gold/"
local SKIN_PINK_PATH_HEADER = "@assets:img/skin/pink/"
local SKIN_BLUE_PATH_HEADER = "@assets:img/skin/blue/"
local SKIN_SILVER_PATH_HEADER = "@assets:img/skin/silver/"

local SKIN_GOLD_SAMPLE_IMAGE_PATH = "@assets:img/skin/skin_setting_image_gold.png"
local SKIN_PINK_SAMPLE_IMAGE_PATH = "@assets:img/skin/skin_setting_image_pink.png"
local SKIN_BLUE_SAMPLE_IMAGE_PATH = "@assets:img/skin/skin_setting_image_blue.png"
local SKIN_SILVER_SAMPLE_IMAGE_PATH = "@assets:img/skin/skin_setting_image_silver.png"

local SGAME_ACCESSBILITY_SETTING_PAGES_TABLE = "cm_cn_tmgp_sgame_accessbility_setting_pages"

--- 脚本里面界面配置项相关的
local KEY_SKIN_TYPE = "key_skin_type"
local KEY_IS_SKIN_CHECKED = "key_is_skin_checked"

--界面资源字段提取
local SKIN_TABLE_STAT_FIELD = "stat"
local SKIN_TABLE_EXCLUDE = "exclude"
local SKIN_TABLE_RESTORE = "restore"

local SKIN_TABLE_HERO_ATTACK_MODE = "heroAttackMode"
local SKIN_TABLE_HERO_ATTACK_MODE_FREE = "FREE"
local SKIN_TABLE_HERO_ATTACK_MODE_ADVANCED_FREE = "ADVANCED_FREE"
local SKIN_TABLE_HERO_ATTACK_MODE_LOCK = "LOCK"

local SKIN_TABLE_SHOP = "shop";
local SKIN_TABLE_SHOP_LEFT = "LEFT"
local SKIN_TABLE_SHOP_RIGHT = "RIGHT"

local SKIN_TABLE_FLOAT_WINDOW = "float_window";
local SKIN_TABLE_FLOAT_LEFT_WINDOW = "LEFT_WINDOW"
local SKIN_TABLE_FLOAT_RIGHT_WINDOW = "RIGHT_WINDOW"

local SKIN_TABLE_SUMMONER_SKILL_COUNT = "summonerSkillCount"
local SKIN_TABLE_SUMMONER_WITH_TWO_SKILL = "2"
local SKIN_TABLE_SUMMONER_WITH_THREE_SKILL = "3"
local SKIN_TABLE_SUMMONER_WITH_FOUR_SKILL = "4"

local SKIN_TABLE_LARGE_MAP = "largeMap"
local SKIN_TABLE_LARGE_MAP_HIDE = "HIDE"
local SKIN_TABLE_LARGE_MAP_LEFT = "LEFT"
local SKIN_TABLE_LARGE_MAP_RIGHT = "RIGHT"
local SKIN_TABLE_LARGE_MAP_LEFT_EQUIPMENT = "leftEquipment"
local SKIN_TABLE_LARGE_MAP_RIGHT_EQUIPMENT = "rightEquipment"
local SKIN_TABLE_VALUE_TUITA = "43"

local SKIN_TABLE_CHAT = "chat"
local SKIN_TABLE_LARGE_CHAT_EQUIPMENT = "leftEquipment"
local SKIN_TABLE_LARGE_CHAT_EQUIPMENT = "rightEquipment"

local SKIN_TABLE_HERO_SKILL_COUNT = "heroSkillCount"
local SKIN_TABLE_HERO_WITH_THREE_SKILL = "3"
local SKIN_TABLE_HERO_WITH_FOUR_SKILL = "4"

local SKIN_SWITCH_CLOSED = 1
local TYPE_GOLD_SKIN = 2
local TYPE_PINK_SKIN = 3
local TYPE_BLUE_SKIN = 4
local TYPE_SILVER_SKIN = 5

local LEFT_FLOAT_BALL_ID = "52"
local RIGHT_FLOAT_BALL_ID = "51"

local skin_isInit = false
local skin_isCtrUIInit = false
local skin_type
local skin_checkBox
local skin_isChecked = true
local skin_is18To9 = false
local skin_radioGroupController
local skin_radioButtonGold
local skin_radioButtonPink
local skin_radioButtonBlue
local skin_radioButtonSilver
local skinFloatView
local floatBallView

local filterOnceSkinTable = {}
local skinDisplayTable = {}

local isFirstEnterSkin = true

local skin_lastMapMode
local skin_lastEquipment
local skin_lastAttackMode
local skin_lastChat

local TAG = "skin_script"
local function printLog(msg)
    commonlib_print(TAG, msg)
end

--将产品配置表的字符串anchor转换为整形数字
local function swiftStrAnchorToInt(anchor)
    local value = 0
    if anchor == "TOPLEFT" then
        value = Anchor().TOPLEFT
    elseif anchor == "LEFT" then
        value = Anchor().LEFT
    elseif anchor == "BOTTOMLEFT" then
        value = Anchor().BOTTOMLEFT
    elseif anchor == "TOP" then
        value = Anchor().TOP
    elseif anchor == "CENTER" then
        value = Anchor().CENTER
    elseif anchor == "BOTTOM" then
        value = Anchor().BOTTOM
    elseif anchor == "TOPRIGHT" then
        value = Anchor().TOPRIGHT
    elseif anchor == "RIGHT" then
        value = Anchor().RIGHT
    elseif anchor == "BOTTOMRIGHT" then
        value = Anchor().BOTTOMRIGHT
    end
    return value
end

local function convertSkinTypeToInt(skin_type)
    local skinType = SKIN_SWITCH_CLOSED
    if skin_type == SKIN_TYPE_GOLD then
        skinType = TYPE_GOLD_SKIN
    elseif skin_type == SKIN_TYPE_PINK then
        skinType = TYPE_PINK_SKIN
    elseif skin_type == SKIN_TYPE_BLUE then
        skinType = TYPE_BLUE_SKIN
    elseif skin_type == SKIN_TYPE_SILVER then
        skinType = TYPE_SILVER_SKIN
    end
    return skinType
end

local function reportSkinSwitchStatus()
    local reportLib = Report();
    if reportLib ~= nil then
        reportLib:report({
            table_name = SGAME_ACCESSBILITY_SETTING_PAGES_TABLE,
            report_data = { skin = convertSkinTypeToInt(skin_type), battle = 0, enemy_nearby = 0, teammate = 0, enemy_disappear = 0, buff_time = 0 }
        })
    end
end

------------------------------------- 每局游戏只需要检测一次的情况---------------------------------------------------
local function summonerWithSkills(skinType, skillCount)
    local summonerSkillExclude = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_SUMMONER_SKILL_COUNT][skillCount][SKIN_TABLE_EXCLUDE]
    if summonerSkillExclude == nil then
        return;
    end

    for index, value in pairs(summonerSkillExclude) do
        table.insert(filterOnceSkinTable, value);
    end
end

local function summonerWithTwoSkill(skinType)
    summonerWithSkills(skinType, SKIN_TABLE_SUMMONER_WITH_TWO_SKILL);
end

local function summoneroWithThreeSkill(skinType)
    summonerWithSkills(skinType, SKIN_TABLE_SUMMONER_WITH_THREE_SKILL);
end

local function summonerWithFourSkill(skinType)
    summonerWithSkills(skinType, SKIN_TABLE_SUMMONER_WITH_FOUR_SKILL);
end

local function heroWithSkills(skinType, skillCount)
    local heroSkillExclude = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_HERO_SKILL_COUNT][skillCount][SKIN_TABLE_EXCLUDE];
    if heroSkillExclude == nil then
        return
    end

    for index, value in pairs(heroSkillExclude) do
        table.insert(filterOnceSkinTable, value)
    end
end

local function heroWithThreeSkill(skinType)
    heroWithSkills(skinType, SKIN_TABLE_HERO_WITH_THREE_SKILL);
end

local function heroWithFourSkill(skinType)
    heroWithSkills(skinType, SKIN_TABLE_HERO_WITH_FOUR_SKILL);
end

local function filterHeroAndSkillType()
    --- 首先检测是否是大乔或者干将莫邪(四个技能)
    local heroCount = commonlib_getGameParam(KEY_HERO_SKILL_COUNT)
    printLog("filterHeroAndSkillType heroCount = " .. tostring(heroCount))
    if heroCount == HERO_SKILL_COUNT_THREE then
        heroWithThreeSkill(skin_type)
    else
        heroWithFourSkill(skin_type)
    end

    local summonerSkillCount = commonlib_getGameParam(KEY_SUMMONER_SKILL_COUNT)
    printLog("filterHeroAndSkillType summonerSkillCount = " .. tostring(summonerSkillCount))
    --- 再检测子技能是2,3,4个的情况
    if summonerSkillCount == SUMMONER_SKILL_COUNT_TWO then
        summonerWithTwoSkill(skin_type)
    elseif summonerSkillCount == SUMMONER_SKILL_COUNT_THREE then
        summoneroWithThreeSkill(skin_type)
    else
        summonerWithFourSkill(skin_type)
    end

    if skin_is18To9 then
        table.insert(filterOnceSkinTable, "45")
        table.insert(filterOnceSkinTable, "50")
    end
end

----------------------------------------- 需要多次检测的情况---------------------------------------------------
local function setSkinDisplyTableShowFalse(skinDisplyTableExclude)
    if not skinDisplyTableExclude then
        return;
    end
    for index, value in pairs(skinDisplyTableExclude) do
        if skinDisplayTable[value] ~= nil then
            skinDisplayTable[value].show = false;
        end
    end
end

local function setSkinDisplyTableShowTrue(skinDisplyTableExclude)
    if not skinDisplyTableExclude then
        return;
    end
    for index, value in pairs(skinDisplyTableExclude) do
        if skinDisplayTable[value] ~= nil then
            skinDisplayTable[value].show = true;
        end
    end
end

local function heroAttackModes(skinType, attackMode, includeAttackModeOne, includeAttackModeTwo)
    local heroAttackExclude = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_HERO_ATTACK_MODE][attackMode][SKIN_TABLE_EXCLUDE];
    local heroAttackIncludeOne = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_HERO_ATTACK_MODE][includeAttackModeOne][SKIN_TABLE_EXCLUDE];
    if heroAttackIncludeOne ~= nil then
        setSkinDisplyTableShowTrue(heroAttackIncludeOne)
    end

    local heroAttackIncludeTwo = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_HERO_ATTACK_MODE][includeAttackModeTwo][SKIN_TABLE_EXCLUDE];
    if heroAttackIncludeTwo ~= nil then
        setSkinDisplyTableShowTrue(heroAttackIncludeTwo)
    end
    if heroAttackExclude ~= nil then
        setSkinDisplyTableShowFalse(heroAttackExclude)
    end
end

local function heroFreeAttackMode(skinType)
    --printLog("heroFreeAttackMode=====")
    heroAttackModes(skinType, SKIN_TABLE_HERO_ATTACK_MODE_FREE, SKIN_TABLE_HERO_ATTACK_MODE_ADVANCED_FREE, SKIN_TABLE_HERO_ATTACK_MODE_LOCK);
end

local function heroAdvancedFreeAttackMode(skinType)
    --printLog("heroAdvancedFreeAttackMode=====")
    heroAttackModes(skinType, SKIN_TABLE_HERO_ATTACK_MODE_ADVANCED_FREE, SKIN_TABLE_HERO_ATTACK_MODE_FREE, SKIN_TABLE_HERO_ATTACK_MODE_LOCK);
end

local function heroLockAttackMode(skinType)
    --printLog("heroLockAttackMode=====")
    heroAttackModes(skinType, SKIN_TABLE_HERO_ATTACK_MODE_LOCK, SKIN_TABLE_HERO_ATTACK_MODE_FREE, SKIN_TABLE_HERO_ATTACK_MODE_ADVANCED_FREE);
end

--- 悬浮球皮肤的处理
local function FloatBallWindow(skinType, position)
    local floatBallExclude = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_FLOAT_WINDOW][position][SKIN_TABLE_EXCLUDE]
    if floatBallExclude == nil then
        return
    end

    for index, value in pairs(floatBallExclude) do
        if skinDisplayTable[value] ~= nil then
            skinDisplayTable[value].show = false
        end
    end
end

local function leftFloatBallWindow(skinType)
    FloatBallWindow(skinType, SKIN_TABLE_FLOAT_RIGHT_WINDOW)
end

local function rightFloatBallWindow(skinType)
    FloatBallWindow(skinType, SKIN_TABLE_FLOAT_LEFT_WINDOW)
end

--- 左右出装皮肤处理
local function shopPosition(skinType, position, includePosition)

    local shopPositionExclude = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_SHOP][position][SKIN_TABLE_EXCLUDE]
    if shopPositionExclude == nil then
        return;
    end

    local shopPositionInclude = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_SHOP][includePosition][SKIN_TABLE_EXCLUDE]
    if shopPositionInclude == nil then
        return;
    end
    setSkinDisplyTableShowTrue(shopPositionInclude)
    setSkinDisplyTableShowFalse(shopPositionExclude)
end

local function leftShop(skinType)
    shopPosition(skinType, SKIN_TABLE_SHOP_LEFT, SKIN_TABLE_SHOP_RIGHT)
end

local function rightShop(skinType)
    shopPosition(skinType, SKIN_TABLE_SHOP_RIGHT, SKIN_TABLE_SHOP_LEFT)
end

--- 地图皮肤处理
local function largeMap(skinType, position, includePositionOne, includePositionTwo)
    local largeMapExclude = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_LARGE_MAP][position][SKIN_TABLE_EXCLUDE];
    if largeMapExclude == nil then
        return
    end
    local largeMapIncludeOne = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_LARGE_MAP][includePositionOne][SKIN_TABLE_EXCLUDE];
    local largeMapIncludeTwo = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_LARGE_MAP][includePositionTwo][SKIN_TABLE_EXCLUDE];
    setSkinDisplyTableShowFalse(largeMapExclude)
end

--- 从大地图模式切换回小地图
local function largeMapHide(skinType, lastPosition, equipment)
    local largeMapInclude = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_LARGE_MAP][lastPosition][SKIN_TABLE_RESTORE][equipment];
    if largeMapInclude ~= nil then
        for index, value in pairs(largeMapInclude) do
            if skinDisplayTable[value] ~= nil then
                skinDisplayTable[value].show = true
            end
        end
        if lastPosition == SKIN_TABLE_LARGE_MAP_RIGHT and not (skin_lastAttackMode == HERO_ATTACK_MODE_ADVANCED_FREE) and
                skinDisplayTable[SKIN_TABLE_VALUE_TUITA] ~= nil then
            skinDisplayTable[SKIN_TABLE_VALUE_TUITA].show = false
        end
    end
end

local function hideLargeMap(skinType)
    if skin_lastMapMode == nil or skin_lastEquipment == nil then
        return
    end

    if skin_lastMapMode == LARGE_MAP_LEFT_ZOOMOUT then
        if skin_lastEquipment == SHOP_MENU_POSITION_LEFT then
            largeMapHide(skinType, SKIN_TABLE_LARGE_MAP_LEFT, SKIN_TABLE_LARGE_MAP_LEFT_EQUIPMENT)
        elseif skin_lastEquipment == SHOP_MENU_POSITION_RIGHT then
            largeMapHide(skinType, SKIN_TABLE_LARGE_MAP_LEFT, SKIN_TABLE_LARGE_MAP_RIGHT_EQUIPMENT)
        end
    elseif skin_lastMapMode == LARGE_MAP_RIGHT_ZOOMOUT then
        if skin_lastEquipment == SHOP_MENU_POSITION_LEFT then
            largeMapHide(skinType, SKIN_TABLE_LARGE_MAP_RIGHT, SKIN_TABLE_LARGE_MAP_LEFT_EQUIPMENT)
        elseif skin_lastEquipment == SHOP_MENU_POSITION_RIGHT then
            largeMapHide(skinType, SKIN_TABLE_LARGE_MAP_RIGHT, SKIN_TABLE_LARGE_MAP_RIGHT_EQUIPMENT)
        end
    end
end

local function leftLargeMap(skinType)
    largeMap(skinType, SKIN_TABLE_LARGE_MAP_LEFT, SKIN_TABLE_LARGE_MAP_HIDE, SKIN_TABLE_LARGE_MAP_RIGHT);
end

local function rightLargeMap(skinType)
    largeMap(skinType, SKIN_TABLE_LARGE_MAP_RIGHT, SKIN_TABLE_LARGE_MAP_HIDE, SKIN_TABLE_LARGE_MAP_LEFT);
end

--- 聊天窗口皮肤处理
local function openChatWindow(skinType)
    local openChatWindowExclude = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_CHAT][SKIN_TABLE_EXCLUDE];
    if openChatWindowExclude == nil then
        return
    end
    setSkinDisplyTableShowFalse(openChatWindowExclude)
end

local function chatWindowClosed(skinType, equipment)
    local closeChatWindowInclude = themes[skinType][SKIN_TABLE_STAT_FIELD][SKIN_TABLE_CHAT][SKIN_TABLE_RESTORE][equipment]
    if closeChatWindowInclude == nil then
        return
    end

    for index, value in pairs(closeChatWindowInclude) do
        --printLog("chatWindowClosed" .. tostring(value))
        if skinDisplayTable[value] ~= nil then
            skinDisplayTable[value].show = true
        end
    end

    if not (skin_lastAttackMode == HERO_ATTACK_MODE_ADVANCED_FREE) and
            skinDisplayTable[SKIN_TABLE_VALUE_TUITA] ~= nil then
        skinDisplayTable[SKIN_TABLE_VALUE_TUITA].show = false
    end
end

--- 关闭聊天窗口
local function closeChatWindow(skinType)
    if skin_lastEquipment == SHOP_MENU_POSITION_LEFT then
        chatWindowClosed(skinType, SKIN_TABLE_LARGE_MAP_LEFT_EQUIPMENT)
    elseif skin_lastEquipment == SHOP_MENU_POSITION_RIGHT then
        chatWindowClosed(skinType, SKIN_TABLE_LARGE_MAP_RIGHT_EQUIPMENT)
    end
end

local function showFloatBallSkinByParam(position)
    --printLog("wqh showFloatBallSkinByParam position: " .. tostring(position) .. " skinview: " .. tostring(skinDisplayTable[position].skinview))
    if skinDisplayTable[position] ~= nil and skinDisplayTable[position].skinview ~= nil then
        commonlib_runOnUIThread(function()
            local isShow = floatBallView:isShowing()
            if isShow then
                skinDisplayTable[position].skinview:show()
            else
                skinDisplayTable[position].skinview:hide()
            end
        end)
    end
end

local function handleMapByMode(mapMode)
    if mapMode == LARGE_MAP_LEFT_ZOOMOUT then
        leftLargeMap(skin_type)
    elseif mapMode == LARGE_MAP_RIGHT_ZOOMOUT then
        rightLargeMap(skin_type)
    else
        hideLargeMap(skin_type)
    end
    skin_lastMapMode = mapMode
end

local function handleChatWindow(isOpen)
    if skin_lastMapMode ~= LARGE_MAP_RIGHT_ZOOMOUT then
        if isOpen then
            openChatWindow(skin_type)
        else
            closeChatWindow(skin_type)
        end
    end
    skin_lastChat = isOpen
end

local function handleQuipment(equipment)
    if equipment == SHOP_MENU_POSITION_LEFT then
        leftShop(skin_type)
        leftFloatBallWindow(skin_type)
    else
        rightShop(skin_type)
        rightFloatBallWindow(skin_type)
    end
    skin_lastEquipment = equipment
end

local function handleAttackMode(attackMode)
    if attackMode == HERO_ATTACK_MODE_FREE then
        heroFreeAttackMode(skin_type)
    elseif attackMode == HERO_ATTACK_MODE_ADVANCED_FREE then
        heroAdvancedFreeAttackMode(skin_type)
    else
        heroLockAttackMode(skin_type)
    end
    skin_lastAttackMode = attackMode
end

local function handleEquipmentAndAttackMode()
    handleQuipment(commonlib_getGameParam(KEY_SHOP_MENU_POSITION))
    handleAttackMode(commonlib_getGameParam(KEY_HERO_ATTACK_MODE))
end

local function handleFloatBallSkin()
    if skin_lastEquipment == SHOP_MENU_POSITION_LEFT then
        showFloatBallSkinByParam(RIGHT_FLOAT_BALL_ID)
    else
        showFloatBallSkinByParam(LEFT_FLOAT_BALL_ID)
    end
end

local function createSkin(key, value)
    --printLog("createSkin begin")
    if key == nil or value == nil then
        return
    end

    local imagePath
    if skin_type == SKIN_TYPE_GOLD then
        imagePath = SKIN_GOLD_PATH_HEADER .. value[1]
    elseif skin_type == SKIN_TYPE_PINK then
        imagePath = SKIN_PINK_PATH_HEADER .. value[1]
    elseif skin_type == SKIN_TYPE_SILVER then
        imagePath = SKIN_SILVER_PATH_HEADER .. value[1]
    elseif skin_type == SKIN_TYPE_BLUE then
        imagePath = SKIN_BLUE_PATH_HEADER .. value[1]
    end

    local AnchorPoint = swiftStrAnchorToInt(value[2]);
    local skinImgView = skinFloatView:addImageView(imagePath, AnchorPoint, value[3], value[4],
        value[5], value[6], ZOrder().zorder_bottom)

    if skinDisplayTable ~= nil and skinImgView ~= nil then
        skinDisplayTable[key] = { skinview = skinImgView, show = true, oldShow = true }
    end
end

local function readTableToCreateSkin(typeSkin)
    printLog("readTableToCreateSkin begin")
    local tables = themes[typeSkin]["widget"]
    for index, filterId in pairs(tables) do
        for i = 1, #filterOnceSkinTable do
            if index == filterOnceSkinTable[i] then
                filterId = nil
            end
        end
        createSkin(index, filterId)
    end
end

local function firstUpdateSkinView(screenState)
    for key, value in pairs(skinDisplayTable) do
        if value.skinview ~= nil then
            if value.show and screenState == SKIN_ORIENTATION_LANDSCAPE then
                printLog("firstUpdateSkinView show skin id: " .. tostring(key))
                value.skinview:show()
            else
                printLog("firstUpdateSkinView hide skin id: " .. tostring(key))
                value.skinview:hide()
            end
        end
        value.oldShow = value.show;
    end
    isFirstEnterSkin = false;
end

local function exceptFirstUpdateSkillView(screenState)
    for key, value in pairs(skinDisplayTable) do
        --printLog("exceptFirstUpdateSkillView show all skin id: " .. tostring(key) .. "   show = " .. tostring(value.show))
        if value.show ~= value.oldShow then
            if value.skinview ~= nil then
                if value.show and screenState == SKIN_ORIENTATION_LANDSCAPE then
                    --printLog("exceptFirstUpdateSkillView show skin id: " .. tostring(key))
                    value.skinview:show()
                else
                    --printLog("exceptFirstUpdateSkillView hide skin id: " .. tostring(key))
                    value.skinview:hide()
                end
            end
        end
        value.oldShow = value.show;
    end
end

--- 真正在界面上显示皮肤的函数
--- 由于需要操作view组件，所以该方法必须要在主线程调用
local function updateSkinView()
    printLog("updateSkinView begin")
    if skinDisplayTable == nil then
        printLog("updateSkinView skinDisplayTable is nil")
        return
    end

    --- 添加当前屏幕横竖屏状态的判断
    --- 竖屏的时候不显示皮肤
    local gameAssistant = GameAssistant()
    -- screenState横竖屏状态 1代表横屏 2代表竖屏
    local screenState = gameAssistant:screenState()
    printLog("updateSkinView screenState: " .. tostring(screenState));
    if isFirstEnterSkin then
        firstUpdateSkinView(screenState)
    else
        exceptFirstUpdateSkillView(screenState)
    end
end

local function updateSkinViewOnUIThread()
    commonlib_runOnUIThread(function()
        updateSkinView()
    end)
end

--- 重置所有皮肤view，将其都设为显示状态
local function resetAllSkinViews()
    printLog("resetAllSkinView begin")
    if skinFloatView ~= nil then
        skinFloatView:show()
    end
end

--- 隐藏所有皮肤view
local function hideAllSkinViews()
    printLog("hideAllSkinView begin")
    if skinFloatView ~= nil then
        skinFloatView:hide()
    end
end

--- 销毁所有皮肤view
local function destroyAllSkinViews()
    printLog("destroyAllSkinView begin")
    if skinDisplayTable == nil then
        printLog("skinDisplayTable is nil")
        return
    end

    for key, value in pairs(skinDisplayTable) do
        if value.skinview ~= nil then
            value.skinview:destroy()
        end
    end

    --清空表
    skinDisplayTable = {}
end

--- 销毁本局游戏创建的所有皮肤资源
local function destroySkinViewResources()
    printLog("destroySkinViewResources begin ")
    commonlib_runOnUIThread(destroyAllSkinViews)
end

--- 由于需要操作view组件，所以该方法必须要在主线程调用
local function initSkinViewResources()
    printLog("initSkinViewResources begin")
    --- 如果皮肤checkbox没被勾选，则不做处理
    if skin_checkBox == nil or not skin_checkBox:isChecked() then
        return
    end

    if skinFloatView == nil then
        printLog("initSkinViewResources skinFloatView is nil")
        return
    end

    resetAllSkinViews()
    skin_lastMapMode = nil
    skin_lastEquipment = nil
    skin_lastAttackMode = nil
    skin_lastChat = nil

    --- 待显示皮肤表需要先置空
    if #skinDisplayTable > 0 then
        skinDisplayTable = {}
    end

    --- 过滤英雄技能表需要置空
    if #filterOnceSkinTable > 0 then
        filterOnceSkinTable = {}
    end

    --- 根据英雄技能过滤非本局要显示的皮肤
    filterHeroAndSkillType()

    readTableToCreateSkin(skin_type)
    handleEquipmentAndAttackMode()
    updateSkinView()
end

--- 皮肤radiobutton勾选切换的时候调用
local function swiftSkinViewResources()
    printLog("swiftSkinViewResources begin ")
    destroyAllSkinViews()
    initSkinViewResources()
end

--- 开启皮肤系统checkbox勾选或者取消的回调函数
local function skinCheckboxUICallback(id, isChecked)
    if skin_checkBox == nil or skin_radioButtonGold == nil or skin_radioButtonPink == nil then
        printLog("skinCheckboxUICallback nil fail")
        return
    end

    if id == skin_checkBox:getId() then
        if skin_checkBox:isChecked() then
            printLog("皮肤checkbox被选中 " .. tostring(id))
            skin_radioButtonGold:setEnabled(true)
            skin_radioButtonPink:setEnabled(true)
            skin_radioButtonSilver:setEnabled(true)
            skin_radioButtonBlue:setEnabled(true)
            skin_radioButtonGold:setChecked(true)
            commonlib_setSharedPrefBoolean(KEY_IS_SKIN_CHECKED, true)
        else
            printLog("皮肤checkbox取消勾选 " .. tostring(id))
            skin_radioButtonGold:setChecked(false)
            skin_radioButtonPink:setChecked(false)
            skin_radioButtonSilver:setChecked(false)
            skin_radioButtonBlue:setChecked(false)

            skin_radioButtonGold:setEnabled(false)
            skin_radioButtonPink:setEnabled(false)
            skin_radioButtonSilver:setEnabled(false)
            skin_radioButtonBlue:setEnabled(false)

            -- 销毁皮肤资源表
            destroyAllSkinViews()
            commonlib_setSharedPrefBoolean(KEY_IS_SKIN_CHECKED, false)
            --commonlib_setSharedPrefString(KEY_SKIN_TYPE, SKIN_TYPE_GOLD)
        end
    end
end

--- 皮肤radiobutton选中或者取消的回调函数
local function skinRadioGroupUICallback(id, isChecked)
    if skin_radioButtonGold == nil or skin_radioButtonPink == nil or skin_radioButtonSilver == nil or skin_radioButtonBlue == nil then
        printLog("skinRadioGroupUICallback nil fail")
        return
    end

    if id == skin_radioButtonGold:getId() and isChecked then
        printLog("gold皮肤被选中 " .. tostring(id))
        skin_type = SKIN_TYPE_GOLD
        swiftSkinViewResources()
    elseif id == skin_radioButtonPink:getId() and isChecked then
        printLog("pink皮肤被选中 " .. tostring(id))
        skin_type = SKIN_TYPE_PINK
        swiftSkinViewResources()
    elseif id == skin_radioButtonSilver:getId() and isChecked then
        printLog("silver皮肤被选中 " .. tostring(id))
        skin_type = SKIN_TYPE_SILVER
        swiftSkinViewResources()
    elseif id == skin_radioButtonBlue:getId() and isChecked then
        printLog("blue皮肤被选中 " .. tostring(id))
        skin_type = SKIN_TYPE_BLUE
        swiftSkinViewResources()
    end

    if skin_type ~= nil then
        commonlib_setSharedPrefString(KEY_SKIN_TYPE, skin_type)
    end
end

local function isSkinTypeSelected(skinType, isSkinChecked)
    if skinType == nil or skin_type == nil or not isSkinChecked then
        return false
    end

    if skinType == skin_type then
        return true
    else
        return false
    end
end

--- 设置皮肤坐标在x轴的偏移量
local function setSkinXOffset()
    printLog("开始为坐标设置偏移量");
    for i, skinInfo in pairs(themes) do
        local widget = skinInfo["widget"];
        for j, rect in pairs(widget) do
            if rect[2] == "BOTTOMRIGHT" then
                rect[3] = rect[3] + X_OFFSET_IN_18TO9_SCREEN;
            end
        end
    end
end

--- 初始化Buff设置页面UI函数
local function initSkinSettingUI()
    skin_type = commonlib_getSharedPrefString(KEY_SKIN_TYPE, SKIN_TYPE_GOLD)
    skin_isChecked = commonlib_getSharedPrefBoolean(KEY_IS_SKIN_CHECKED, true)
    printLog("initSkinSettingUI begin skin_type: " .. skin_type)

    local settingView = SettingView()
    local settingPanel = settingView:addTableView(SKIN_BUTTON)

    local skinSettingParam
    local skinSettingParams

    --- 添加开启皮肤系统的checkbox
    skinSettingParam = create("RelativeLayoutParam")
    skinSettingParams = {
        layout_marginTop = "10dp",
        layout_marginLeft = "10dp"
    }
    skinSettingParam:setLayoutParam(skinSettingParams)
    skin_checkBox = settingPanel:addCheckBoxView(SKIN_SWITCH_TEXT, skin_isChecked, skinSettingParam, skinCheckboxUICallback)

    skin_radioGroupController = settingPanel:createRadioGroupController(skinRadioGroupUICallback)

    --- 添加黄金斗士radio button
    skinSettingParam = create("RelativeLayoutParam")
    skinSettingParams = {
        layout_below = skin_checkBox:getId(),
        layout_marginTop = "12dp",
        layout_marginLeft = "35dp"
    }
    skinSettingParam:setLayoutParam(skinSettingParams)
    skin_radioButtonGold = settingPanel:addRadioButton(SKIN_GOLD_TEXT, isSkinTypeSelected(SKIN_TYPE_GOLD, skin_isChecked),
        skinSettingParam, nil, skin_radioGroupController:getId())

    --- 添加甜心女王radio button
    skinSettingParam = create("RelativeLayoutParam")
    skinSettingParams = {
        layout_below = skin_checkBox:getId(),
        layout_toRightOf = skin_radioButtonGold:getId(),
        layout_marginTop = "12dp",
        layout_marginLeft = "180dp"
    }
    skinSettingParam:setLayoutParam(skinSettingParams)
    skin_radioButtonPink = settingPanel:addRadioButton(SKIN_PINK_TEXT, isSkinTypeSelected(SKIN_TYPE_PINK, skin_isChecked),
        skinSettingParam, nil, skin_radioGroupController:getId())

    --- 添加黄金斗士示例图
    skinSettingParam = create("RelativeLayoutParam")
    skinSettingParams = {
        layout_width = "110dp",
        layout_height = "69dp",
        layout_below = skin_radioButtonGold:getId(),
        layout_marginTop = "12dp",
        layout_marginLeft = "35dp"
    }
    skinSettingParam:setLayoutParam(skinSettingParams)
    local skinSettingImageGold = settingPanel:addImageView(SKIN_GOLD_SAMPLE_IMAGE_PATH, skinSettingParam, nil)

    --- 添加甜心女王示例图
    skinSettingParam = create("RelativeLayoutParam")
    skinSettingParams = {
        layout_width = "110dp",
        layout_height = "69dp",
        layout_below = skin_radioButtonGold:getId(),
        layout_toRightOf = skinSettingImageGold:getId(),
        layout_marginTop = "12dp",
        layout_marginLeft = "180dp",
    }
    skinSettingParam:setLayoutParam(skinSettingParams)
    settingPanel:addImageView(SKIN_PINK_SAMPLE_IMAGE_PATH, skinSettingParam, nil)

    --- 添加圣银骑士radio button
    skinSettingParam = create("RelativeLayoutParam")
    skinSettingParams = {
        layout_below = skinSettingImageGold:getId(),
        layout_marginTop = "12dp",
        layout_marginLeft = "35dp"
    }
    skinSettingParam:setLayoutParam(skinSettingParams)
    skin_radioButtonSilver = settingPanel:addRadioButton(SKIN_SILVER_TEXT, isSkinTypeSelected(SKIN_TYPE_SILVER, skin_isChecked),
        skinSettingParam, nil, skin_radioGroupController:getId())

    --- 添加炫蓝勇者radio button
    skinSettingParam = create("RelativeLayoutParam")
    skinSettingParams = {
        layout_below = skinSettingImageGold:getId(),
        layout_toRightOf = skin_radioButtonSilver:getId(),
        layout_marginTop = "12dp",
        layout_marginLeft = "180dp"
    }
    skinSettingParam:setLayoutParam(skinSettingParams)
    skin_radioButtonBlue = settingPanel:addRadioButton(SKIN_BLUE_TEXT, isSkinTypeSelected(SKIN_TYPE_BLUE, skin_isChecked),
        skinSettingParam, nil, skin_radioGroupController:getId())

    --- 添加圣银骑士示例图
    skinSettingParam = create("RelativeLayoutParam")
    skinSettingParams = {
        layout_width = "110dp",
        layout_height = "69dp",
        layout_below = skin_radioButtonSilver:getId(),
        layout_marginTop = "12dp",
        layout_marginLeft = "35dp",
        layout_marginBottom = "15dp"
    }
    skinSettingParam:setLayoutParam(skinSettingParams)
    local skinSettingImageSilver = settingPanel:addImageView(SKIN_SILVER_SAMPLE_IMAGE_PATH, skinSettingParam, nil)

    --- 添加炫蓝勇者示例图
    skinSettingParam = create("RelativeLayoutParam")
    skinSettingParams = {
        layout_width = "110dp",
        layout_height = "69dp",
        layout_below = skin_radioButtonSilver:getId(),
        layout_toRightOf = skinSettingImageSilver:getId(),
        layout_marginTop = "12dp",
        layout_marginLeft = "180dp",
        layout_marginBottom = "15dp"
    }
    skinSettingParam:setLayoutParam(skinSettingParams)
    settingPanel:addImageView(SKIN_BLUE_SAMPLE_IMAGE_PATH, skinSettingParam, nil)
end

--- 设置面板的界面控制函数
local function initSkinConfigUI()
    if not skin_isCtrUIInit then
        --- 初始化UI界面
        initSkinSettingUI()
        skin_isCtrUIInit = true
    end
end

local function initSkinFloatView()
    --- 初始化添加皮肤的悬浮窗主view
    skinFloatView = UnClickableFloatView()
    floatBallView = TopSmallView()
end

--- 创建本局游戏所需的所有皮肤资源
local function createSkinViewResources()
    printLog("createSkinViewResources begin ")
    commonlib_runOnUIThread(initSkinViewResources)
end

local function onJustEnterGame()
--    reportSkinSwitchStatus()
end

local function onGameStart()
    printLog("onGameStart")
    createSkinViewResources()
end

local function onGameRunning()
    --printLog("onGameRunning")
    handleFloatBallSkin()
end

local function onGameOver()
    printLog("onGameOver")
    destroySkinViewResources()
end

local function onFullCoverStateChange(isFullCover)
    printLog("onFullCoverStateChange isFullCover: " .. tostring(isFullCover))
    commonlib_runOnUIThread(function()
        if isFullCover then
            hideAllSkinViews()
        else
            resetAllSkinViews()
        end
    end)
end

local function onMapModeChange(mapMode)
    printLog("onMapModeChange mapMode: " .. tostring(mapMode))
    handleMapByMode(mapMode)
    updateSkinViewOnUIThread()
end

local function onChatWindowOpenStateChange(isOpen)
    printLog("onChatWindowOpenStateChange isOpen: " .. tostring(isOpen))
    handleChatWindow(isOpen)
    updateSkinViewOnUIThread()
end

local function onEquipmentChange(equipment)
    printLog("onEquipmentChange equipment: " .. tostring(equipment))
    handleQuipment(equipment)
    updateSkinViewOnUIThread()
end

local function onAttackModeChange(attackMode)
    printLog("onAttackModeChange attackMode: " .. tostring(attackMode))
    handleAttackMode(attackMode)
    updateSkinViewOnUIThread()
end

local function registerGameEvents()
    commonlib_registerCallback(common_game_events_callbacks.common_just_enter_game, onJustEnterGame)
    commonlib_registerCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_registerCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_registerCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_registerCallback(common_game_events_callbacks.common_full_cover, onFullCoverStateChange)
    commonlib_registerCallback(common_game_events_callbacks.common_map_mode, onMapModeChange)
    commonlib_registerCallback(common_game_events_callbacks.common_chat_window, onChatWindowOpenStateChange)
    commonlib_registerCallback(common_game_events_callbacks.common_equipment, onEquipmentChange)
    commonlib_registerCallback(common_game_events_callbacks.common_attck_mode, onAttackModeChange)
end

local function unregisterGameEvents()
    commonlib_unregisterCallback(common_game_events_callbacks.common_just_enter_game, onJustEnterGame)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_start, onGameStart)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_running, onGameRunning)
    commonlib_unregisterCallback(common_game_events_callbacks.common_game_over, onGameOver)
    commonlib_unregisterCallback(common_game_events_callbacks.common_full_cover, onFullCoverStateChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_map_mode, onMapModeChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_chat_window, onChatWindowOpenStateChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_equipment, onEquipmentChange)
    commonlib_unregisterCallback(common_game_events_callbacks.common_attck_mode, onAttackModeChange)
end

--- 初始化与反初始化
local function init()
    printLog("init")
    registerGameEvents()
    if not skin_isInit then
        initSkinFloatView()
        skin_isInit = true
    end
    initSkinConfigUI()

    if commonlib_isScreenRatio18To9() then
        printLog("用户屏幕比例为 18:9, 需要去做特殊处理")
        skin_is18To9 = true
        setSkinXOffset()
    end
end

local function uninit()
    printLog("uninit")
    skin_isInit = false
    skin_isCtrUIInit = false
    skin_is18To9 = false

    if skin_checkBox ~= nil then
        skin_checkBox = nil
    end

    if skin_radioGroupController ~= nil then
        skin_radioGroupController:destroy()
        skin_radioGroupController = nil
    end

    if skin_radioButtonGold ~= nil then
        skin_radioButtonGold:destroy()
        skin_radioButtonGold = nil
    end

    if skin_radioButtonPink ~= nil then
        skin_radioButtonPink:destroy()
        skin_radioButtonPink = nil
    end

    if skin_radioButtonBlue ~= nil then
        skin_radioButtonBlue:destroy()
        skin_radioButtonBlue = nil
    end

    if skin_radioButtonSilver ~= nil then
        skin_radioButtonSilver:destroy()
        skin_radioButtonSilver = nil
    end

    if skinFloatView ~= nil then
        skinFloatView:destroy()
        skinFloatView = nil
    end

    if floatBallView ~= nil then
        floatBallView = nil
    end

    if skinDisplayTable ~= nil then
        skinDisplayTable = nil
    end

    if filterOnceSkinTable ~= nil then
        filterOnceSkinTable = nil
    end
    unregisterGameEvents()
end

table.insert(common_life_circle_callbacks, { init, uninit })



